// BonTuner.cpp: CBonTuner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

// BonDriver_UDP݊̃pCvBonDriver
// NCAgASYNCBUFFTIMEbȏ̃pCv݂̒x񕜂ׂłȂ

#include <Windows.h>
#include <assert.h>
#include "BonTuner.h"

#define PIPE_NODE_NUM		10

//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// ~[ebNX
#define MUTEX_NAME			TEXT("BonDriver_Pipe")

// pCv
#define PIPE_NAME			TEXT("\\\\.\\pipe\\BonDriver_Pipe%02lu")

// MTCY
#define TSDATASIZE			48128			// TSf[^̃TCY

// FIFOobt@ݒ
#define ASYNCBUFFTIME		2											// obt@ = 2b
#define ASYNCBUFFSIZE		( 0x200000 / TSDATASIZE * ASYNCBUFFTIME )	// 16MbpsƂ

#define REQRESERVNUM		16				// 񓯊NGXg\
#define REQPOLLINGWAIT		10				// 񓯊NGXg|[OԊu(ms)

// 񓯊NGXg
#define IORS_IDLE			0x00			// NGXg
#define IORS_BUSY			0x01			// NGXgM	
#define IORS_RECV			0x02			// MAXgA҂


//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

CBonTuner::CBonTuner()
	: m_hMutex(NULL)
	, m_pIoReqBuff(NULL)
	, m_pIoPushReq(NULL)
	, m_pIoPopReq(NULL)
	, m_pIoGetReq(NULL)
	, m_dwBusyReqNum(0UL)
	, m_dwReadyReqNum(0UL)
	, m_hPushIoThread(NULL)
	, m_hPopIoThread(NULL)
	, m_hOnStreamEvent(NULL)
	, m_dwCurSpace(0UL)
	, m_dwCurChannel(0xFFFFFFFFUL)
	, m_hPipe(INVALID_HANDLE_VALUE)
{
	m_pThis = this;

	// NeBJZNV
	::InitializeCriticalSection(&m_CriticalSection);
}

CBonTuner::~CBonTuner()
{
	// JĂꍇ͕
	CloseTuner();

	// NeBJZNV폜
	::DeleteCriticalSection(&m_CriticalSection);

	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner()
{
	//return SetChannel(0UL,0UL);

	return TRUE;
}

void CBonTuner::CloseTuner()
{
	// XbhIvZbg
	m_bLoopIoThread = FALSE;

	// CxgJ
	if (m_hOnStreamEvent) {
		::CloseHandle(m_hOnStreamEvent);
		m_hOnStreamEvent = NULL;
	}

	// XbhI
	if(m_hPushIoThread){
		if(::WaitForSingleObject(m_hPushIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPushIoThread, 0);
			::OutputDebugString(TEXT("BonDriver_Pipe: CBonTuner::CloseTuner() ::TerminateThread(m_hPushIoThread)\n"));
			}

		::CloseHandle(m_hPushIoThread);
		m_hPushIoThread = NULL;
		}

	if(m_hPopIoThread){
		if(::WaitForSingleObject(m_hPopIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPopIoThread, 0);
			::OutputDebugString(TEXT("BonDriver_Pipe: CBonTuner::CloseTuner() ::TerminateThread(m_hPopIoThread)\n"));
			}

		::CloseHandle(m_hPopIoThread);
		m_hPopIoThread = NULL;
		}


	// obt@J
	FreeIoReqBuff(m_pIoReqBuff);
	m_pIoReqBuff = NULL;
	m_pIoPushReq = NULL;
	m_pIoPopReq = NULL;
	m_pIoGetReq = NULL;

	m_dwBusyReqNum = 0UL;
	m_dwReadyReqNum = 0UL;

		// hCoN[Y
	if(m_hPipe != INVALID_HANDLE_VALUE){
		::CloseHandle(m_hPipe);
		m_hPipe = INVALID_HANDLE_VALUE;
		}

	// `l
	m_dwCurSpace = 0UL;
	m_dwCurChannel = 0xFFFFFFFFUL;

	// ~[ebNXJ
	if(m_hMutex){
		::ReleaseMutex(m_hMutex);
		::CloseHandle(m_hMutex);
		m_hMutex = NULL;
		}
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	// I`FbN
	if(!m_hOnStreamEvent || !m_bLoopIoThread)return WAIT_ABANDONED;

	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(m_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\ or `[iꂽ
			return (m_bLoopIoThread)? dwRet : WAIT_ABANDONED;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
		}
}

const DWORD CBonTuner::GetReadyCount()
{
	// o\TSf[^擾
	return m_dwReadyReqNum;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE *pSrc = NULL;

	// TSf[^obt@o
	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
			}

		return TRUE;
		}

	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	if(!m_pIoGetReq)return FALSE;

	// TSf[^obt@o
	if(m_dwReadyReqNum){
		if(m_pIoGetReq->dwState == IORS_RECV){

			// f[^Rs[
			*pdwSize = m_pIoGetReq->dwRxdSize;
			*ppDst = m_pIoGetReq->RxdBuff;

			// obt@ʒui߂
			::EnterCriticalSection(&m_CriticalSection);
			m_pIoGetReq = m_pIoGetReq->pNext;
			m_dwReadyReqNum--;
			*pdwRemain = m_dwReadyReqNum;
			::LeaveCriticalSection(&m_CriticalSection);

			return TRUE;
			}
		else{
			// O
			return FALSE;
			}
		}
	else{
		// o\ȃf[^Ȃ
		*pdwSize = 0;
		*pdwRemain = 0;

		return TRUE;
		}
}

void CBonTuner::PurgeTsStream()
{
	// obt@o\f[^p[W

	::EnterCriticalSection(&m_CriticalSection);
	m_pIoGetReq = m_pIoPopReq;
	m_dwReadyReqNum = 0;
	::LeaveCriticalSection(&m_CriticalSection);
}

void CBonTuner::Release()
{
	// CX^XJ
	delete this;
}

LPCTSTR CBonTuner::GetTunerName(void)
{
	// `[iԂ
	return TEXT("UDP/Compat");
}

const BOOL CBonTuner::IsTunerOpening(void)
{
	// `[i̎gp̗LԂ(SvZXʂ)
	HANDLE hMutex = ::OpenMutex(MUTEX_ALL_ACCESS, FALSE, MUTEX_NAME);
	
	if(hMutex){
		// Ƀ`[i͊JĂ
		::CloseHandle(hMutex);
		return TRUE;
		}
	else{
		// `[i͊JĂȂ
		return FALSE;
		}
}

LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	// gp\ȃ`[jOԂԂ
	switch(dwSpace){
		case 0UL :	return TEXT("UDP/Compat");
		default  :	return NULL;
		}
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	// gp\ȃ`lԂ
	if(dwSpace > 0 || (dwChannel >= PIPE_NODE_NUM))return NULL;
	static TCHAR buf[32];
	wsprintf(buf,TEXT("Pipeԍ %lu") , dwChannel);
	return buf;
}

const DWORD CBonTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return m_dwCurSpace;
}

const DWORD CBonTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

CBonTuner::AsyncIoReq * CBonTuner::AllocIoReqBuff(const DWORD dwBuffNum)
{
	if(dwBuffNum < 2)return NULL;

	// mۂ
	AsyncIoReq *pNewBuff = new AsyncIoReq [dwBuffNum];
	if(!pNewBuff)return NULL;

	// [NA
	::ZeroMemory(pNewBuff, sizeof(AsyncIoReq) * dwBuffNum);

	// N\z
	DWORD dwIndex;
	for(dwIndex = 0 ; dwIndex < ( dwBuffNum - 1 ) ; dwIndex++){
		pNewBuff[dwIndex].pNext= &pNewBuff[dwIndex + 1];
		}

	pNewBuff[dwIndex].pNext = &pNewBuff[0];

	return pNewBuff;
}

void CBonTuner::FreeIoReqBuff(CBonTuner::AsyncIoReq *pBuff)
{
	if(!pBuff)return;

	// obt@J
	delete [] pBuff;
}

static bool CheckPipeConnection(HANDLE hPipe, HANDLE hEvent, OVERLAPPED *pOl, bool *pbWait)
{
	if (!*pbWait) {
		::ZeroMemory(pOl, sizeof(OVERLAPPED));
		pOl->hEvent = hEvent;
		if (!::ConnectNamedPipe(hPipe, pOl)) {
			// łɐڑĂ\
			DWORD dwErr = ::GetLastError();
			if (dwErr == ERROR_IO_PENDING) *pbWait = true;
			else if (dwErr == ERROR_PIPE_CONNECTED) return true;
		}
	}
	if (*pbWait && HasOverlappedIoCompleted(pOl)) {
		*pbWait = false;
		return true;
	}
	return false;
}

DWORD WINAPI CBonTuner::PushIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;
	bool bConnect = false;
	bool bWait = false;
	HANDLE hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL);
	OVERLAPPED ol;
	DWORD dwForceSleep = 0;

	assert(pThis->m_hPipe != INVALID_HANDLE_VALUE);

	// hCoTSf[^NGXg𔭍s
	while (pThis->m_bLoopIoThread) {
		// NCAg̐ڑ𒲂ׂ
		if (!bConnect) bConnect = CheckPipeConnection(pThis->m_hPipe, hEvent, &ol, &bWait);

		::EnterCriticalSection(&pThis->m_CriticalSection);
		DWORD dwReady = pThis->m_dwReadyReqNum;
		DWORD dwBusy = pThis->m_dwBusyReqNum;
		::LeaveCriticalSection(&pThis->m_CriticalSection);

		if (dwReady >= ASYNCBUFFSIZE - REQRESERVNUM) {
			// obt@ꂻȂ̂ŃEFCg
			dwForceSleep = (ASYNCBUFFTIME * 1000 + 500) / 100;
		}

		if (dwForceSleep) {
			::Sleep(100);
			dwForceSleep--;
		} else if (bConnect && dwBusy < REQRESERVNUM) {
			// NGXg҂K薢Ȃǉ
			// hCoTSf[^NGXg𔭍s
			if (!pThis->PushIoRequest()) {
				// ڑ
				::DisconnectNamedPipe(pThis->m_hPipe);
				bConnect = false;
			}
		} else {
			// NGXg҂t̏ꍇ̓EFCg
			::Sleep(REQPOLLINGWAIT);
		}
	}

	if (bConnect) ::DisconnectNamedPipe(pThis->m_hPipe);
	::CloseHandle(hEvent);
	return 0;
}

DWORD WINAPI CBonTuner::PopIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;
	DWORD dwBusy;

	// σNGXg|[OăNGXg
	// NGXg҂Ȃ܂ł͒EoȂ
	do {
		::EnterCriticalSection(&pThis->m_CriticalSection);
		dwBusy = pThis->m_dwBusyReqNum;
		::LeaveCriticalSection(&pThis->m_CriticalSection);

		// σf[^΃NGXg
		if (!dwBusy || !pThis->PopIoRequest()) {
			// NGXg҂Ȃoȑꍇ̓EFCg
			::Sleep(REQPOLLINGWAIT);
		}
	} while (pThis->m_bLoopIoThread || dwBusy);

	return 0;
}

const BOOL CBonTuner::PushIoRequest()
{
	// hCoɔ񓯊NGXg𔭍s

	assert(m_hPipe != INVALID_HANDLE_VALUE);

	// NGXgZbg
	m_pIoPushReq->dwRxdSize = 0;

	// Cxgݒ
	::ZeroMemory(&m_pIoPushReq->OverLapped, sizeof(OVERLAPPED));
	if(!(m_pIoPushReq->OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return FALSE;
	
	// PipeǂݎvXfXI
	if (!::ReadFile(m_hPipe, m_pIoPushReq->RxdBuff, sizeof(m_pIoPushReq->RxdBuff), NULL, &m_pIoPushReq->OverLapped) &&
		::GetLastError() != ERROR_IO_PENDING)
	{
		::CloseHandle(m_pIoPushReq->OverLapped.hEvent);
		return FALSE;
	}
	
	m_pIoPushReq->dwState = IORS_BUSY;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPushReq = m_pIoPushReq->pNext;
	m_dwBusyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	return TRUE;
}

const BOOL CBonTuner::PopIoRequest()
{
	// 񓯊NGXg

	assert(m_hPipe != INVALID_HANDLE_VALUE);

	// ԃ`FbN
	if(m_pIoPopReq->dwState != IORS_BUSY){
		// O
		return TRUE;
		}

	// NGXg擾
	BOOL bRet = ::GetOverlappedResult(m_hPipe, &m_pIoPopReq->OverLapped, &m_pIoPopReq->dwRxdSize, FALSE);

	// G[`FbN
	if(!bRet){
		if(::GetLastError() == ERROR_IO_INCOMPLETE){
			// 
			return FALSE;
		} else {
			m_pIoPopReq->dwRxdSize = 0;
		}
	}

	// Cxg폜
	::CloseHandle(m_pIoPopReq->OverLapped.hEvent);

	m_pIoPopReq->dwState = IORS_RECV;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPopReq = m_pIoPopReq->pNext;
	m_dwBusyReqNum--;
	m_dwReadyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);
	
	// CxgZbg
	::SetEvent(m_hOnStreamEvent);

	return TRUE;
}


// `lݒ
const BOOL CBonTuner::SetChannel(const BYTE bCh)
{
	return SetChannel((DWORD)0,(DWORD)bCh-13);
}

// `lݒ
const BOOL CBonTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// Lȃ`l
	if(dwSpace > 0 || (dwChannel >= PIPE_NODE_NUM))
		return FALSE;

	// UN[Y
	CloseTuner();

	// obt@m
	if(!(m_pIoReqBuff = AllocIoReqBuff(ASYNCBUFFSIZE))){
		return FALSE;
		}

	// obt@ʒu
	m_pIoPushReq = m_pIoReqBuff;
	m_pIoPopReq = m_pIoReqBuff;
	m_pIoGetReq = m_pIoReqBuff;
	m_dwBusyReqNum = 0;
	m_dwReadyReqNum = 0;

	try{
		// hCoI[v
		TCHAR szName[MAX_PATH];
		::wsprintf(szName, PIPE_NAME, dwChannel);
		m_hPipe = ::CreateNamedPipe(szName, PIPE_ACCESS_INBOUND | FILE_FLAG_OVERLAPPED, PIPE_TYPE_BYTE, 1,
		                            sizeof(m_pIoReqBuff->RxdBuff), sizeof(m_pIoReqBuff->RxdBuff), 3000, NULL);
		if (m_hPipe == INVALID_HANDLE_VALUE) {
			::OutputDebugString(TEXT("BonDriver_Pipe: CBonTuner::OpenTuner() CreateNamedPipe error\n"));
			throw 1UL;
		}

		// Cxg쐬
		if(!(m_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL)))throw 2UL;

		// XbhN
		DWORD dwPushIoThreadID = 0UL, dwPopIoThreadID = 0UL;
		m_hPushIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PushIoThread, this, CREATE_SUSPENDED, &dwPopIoThreadID);
		m_hPopIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PopIoThread, this, CREATE_SUSPENDED, &dwPushIoThreadID);

		if(!m_hPushIoThread || !m_hPopIoThread){
			if(m_hPushIoThread){
				::TerminateThread(m_hPushIoThread, 0UL);
				::CloseHandle(m_hPushIoThread);
				m_hPushIoThread = NULL;
				}

			if(m_hPopIoThread){
				::TerminateThread(m_hPopIoThread, 0UL);
				::CloseHandle(m_hPopIoThread);
				m_hPopIoThread = NULL;
				}

			throw 3UL;
			}

		// XbhJn
		m_bLoopIoThread = TRUE;
		if(::ResumeThread(m_hPushIoThread) == 0xFFFFFFFFUL || ::ResumeThread(m_hPopIoThread) == 0xFFFFFFFFUL)throw 4UL;

		// ~[ebNX쐬
		if(!(m_hMutex = ::CreateMutex(NULL, TRUE, MUTEX_NAME)))throw 5UL;
		}
	catch(const DWORD dwErrorStep){
		// G[
		TCHAR szDebugOut[1024];
		::wsprintf(szDebugOut, TEXT("BonDriver_Pipe: CBonTuner::OpenTuner() dwErrorStep = %lu\n"), dwErrorStep);
		::OutputDebugString(szDebugOut);

		CloseTuner();
		return FALSE;
		}

	// `lXV
	m_dwCurSpace = dwSpace;
	m_dwCurChannel = dwChannel;

	// TSf[^p[W
	PurgeTsStream();

	return TRUE;
}

// Mx擾(0)
const float CBonTuner::GetSignalLevel(void)
{
	return 0;
}
