#include <WinSock2.h>
#include "TsSender.h"
#include "Util.h"


#define MSB(x) ((x) & 0x80000000)


CTsSender::CTsSender()
    : m_hFile(NULL)
    , m_pBuf(NULL)
    , m_curr(NULL)
    , m_tail(NULL)
    , m_unitSize(0)
    , m_fConvTo188(false)
    , m_fTrimPacket(false)
    , m_sock(NULL)
    , m_udpPort(0)
    , m_hPipe(NULL)
    , m_baseTick(0)
    , m_renewSizeTick(0)
    , m_renewDurTick(0)
    , m_pcrCount(0)
    , m_pcr(0)
    , m_basePcr(0)
    , m_initPcr(0)
    , m_fPcr(false)
    , m_fShareWrite(false)
    , m_fFixed(false)
    , m_fPause(false)
    , m_pcrPid(0)
    , m_pcrPidsLen(0)
    , m_fileSize(0)
    , m_duration(0)
    , m_totBase(0)
    , m_totBasePcr(0)
    , m_hash(0)
    , m_speedNum(100)
    , m_speedDen(100)
    , m_initStore(INITIAL_STORE_MSEC)
    , m_fSpecialExtending(false)
    , m_specialExtendInitRate(0)
    , m_adjState(0)
    , m_adjBaseTick(0)
    , m_adjHoldTick(0)
    , m_adjAmount(0)
    , m_adjDelta(0)
{
    m_udpAddr[0] = 0;
    m_pipeName[0] = 0;
    m_liAdjFreq.QuadPart = 0;
    m_liAdjBase.QuadPart = 0;
}


CTsSender::~CTsSender()
{
    Close();
}


bool CTsSender::Open(LPCTSTR name, DWORD salt, bool fUseQpc)
{
    Close();

    // ܂ǂݍ݋LŊJĂ݂
    m_fShareWrite = false;
    m_fFixed = true;
    m_hFile = ::CreateFile(name, GENERIC_READ, FILE_SHARE_READ,
                           0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if (m_hFile == INVALID_HANDLE_VALUE) {
        // ^撆ȂB݋LŊJ
        m_fShareWrite = true;
        m_fFixed = false;
        m_hFile = ::CreateFile(name, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE,
                               0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
        if (m_hFile == INVALID_HANDLE_VALUE) {
            m_hFile = NULL;
            return false;
        }
    }

    // TSpPbg̒Pʂ
    BYTE buf[8192];
    DWORD readBytes;
    if (!::ReadFile(m_hFile, buf, sizeof(buf), &readBytes, NULL)) goto ERROR_EXIT;
    m_unitSize = select_unit_size(buf, buf + readBytes);
    if (m_unitSize < 188) goto ERROR_EXIT;

    // ]ɃpPbg188Byteɋl߂邩ǂ
    m_fTrimPacket = m_fConvTo188 && m_unitSize == 192;

    // ʏƂăt@C擪̃nbVlƂ
    m_hash = CalcHash(buf, min(readBytes, 2048), salt);
    if (m_hash < 0) goto ERROR_EXIT;

    // obt@m
    m_pBuf = new BYTE[m_unitSize * BUFFER_LEN];

    // PCRQPIDNA
    m_pcrPid = m_pcrPidsLen = 0;

    // TOT-PCRΉNA
    m_totBase = -1;

    // QueryPerformanceCounterɂTickJEg␳邩ǂ
    m_adjState = fUseQpc ? 1 : 0;

    long long fileSize = GetFileSize();
    if (fileSize < 0) goto ERROR_EXIT;

    // t@C擪PCRƓ̒擾
    m_fSpecialExtending = false;
    if (Seek(-TS_SUPPOSED_RATE * 2, FILE_END) && m_pcrCount) {
        // t@Cłꍇ
        DWORD finPcr = m_pcr;

        if (!SeekToBegin() || !m_pcrCount) goto ERROR_EXIT;
        m_initPcr = m_pcr;
        m_duration = (int)((finPcr - m_initPcr) / PCR_PER_MSEC) + 2000;
        m_duration = (int)((finPcr - m_initPcr) / PCR_PER_MSEC) +
                     (int)((long long)TS_SUPPOSED_RATE * 2000 / GetRate());
    }
    else if (m_fShareWrite &&
             SeekToBoundary(fileSize / 2, fileSize, buf, sizeof(buf) / 2) &&
             Seek(-TS_SUPPOSED_RATE * 2, FILE_CURRENT) && m_pcrCount)
    {
        // ݋Lt@CłȂꍇ
        long long filePos = GetFilePosition();
        DWORD finPcr = m_pcr;

        if (!SeekToBegin() || !m_pcrCount) goto ERROR_EXIT;
        m_initPcr = m_pcr;
        m_duration = (int)((finPcr - m_initPcr) / PCR_PER_MSEC) + 2000;

        // t@CTCY烌[gvZłȂ
        m_specialExtendInitRate = filePos < 0 || m_duration <= 0 ? TS_SUPPOSED_RATE :
                                  static_cast<int>((filePos + TS_SUPPOSED_RATE * 2) * 1000 / m_duration);
        m_fSpecialExtending = true;
    }
    else {
        // ŒAĐ͂łꍇ
        if (!SeekToBegin() || !m_pcrCount) goto ERROR_EXIT;
        m_initPcr = m_pcr;
        m_duration = 0;
    }

    // IɃt@CTCY̍XV󋵂擾邽
    if (m_fShareWrite) {
        m_renewSizeTick = m_renewDurTick = GetAdjTickCount();
        m_fileSize = fileSize;
    }

    return true;
ERROR_EXIT:
    Close();
    return false;
}


// TickJEg␳̏ݒ
void CTsSender::SetupQpc()
{
    if (m_adjState == 1) {
        // msdn̐ɏ]Č݃Xbh̃vZbTŒ
        ::SetThreadAffinityMask(::GetCurrentThread(), 1);
        if (::QueryPerformanceFrequency(&m_liAdjFreq) &&
            ::QueryPerformanceCounter(&m_liAdjBase))
        {
            m_adjBaseTick = m_adjHoldTick = GetAdjTickCount();
            m_adjAmount = m_adjDelta = 0;
            m_adjState = 2;
        }
    }
}


void CTsSender::SetUdpAddress(LPCSTR addr, unsigned short port)
{
    // pCv]~
    ClosePipe();
    m_pipeName[0] = 0;

    if (!addr[0]) CloseSocket();
    ::lstrcpynA(m_udpAddr, addr, MAX_URI);
    m_udpPort = port;
}


void CTsSender::SetPipeName(LPCTSTR name)
{
    // UDP]~
    CloseSocket();
    m_udpAddr[0] = 0;

    if (::lstrcmp(m_pipeName, name)) {
        ClosePipe();
        ::lstrcpyn(m_pipeName, name, MAX_PATH-1);
    }
}


// ]188ByteTSɕϊ邩ǂ
// pPbgTimestampedTS(192Byte)̏ꍇ̂ݕϊ
void CTsSender::SetConvTo188(bool fConvTo188)
{
    m_fConvTo188 = fConvTo188;
}


void CTsSender::Close()
{
    if (m_hFile) {
        ::CloseHandle(m_hFile);
        m_hFile = NULL;
    }
    if (m_pBuf) {
        delete [] m_pBuf;
        m_pBuf = NULL;
    }
    CloseSocket();
    ClosePipe();
    m_udpAddr[0] = 0;
    m_pipeName[0] = 0;
}


// TSpPbgǂŁAx]
// t@C̏I[ɒBꍇfalseԂ
// KɃ[g䂳
bool CTsSender::Send()
{
    if (!m_hFile) return false;

    // ␳ɂCɑ\邽ߒIɌĂ
    DWORD tick = GetAdjTickCount();

    // ̒XV
    if (m_fShareWrite) {
        DWORD diff = tick - m_renewSizeTick;
        if (diff >= RENEW_SIZE_INTERVAL) {
            long long fileSize = GetFileSize();
            if (fileSize >= 0) {
                if (m_fSpecialExtending && fileSize < m_fileSize) {
                    // eʊmۗ̈悪^Iɂč폜ꂽƉ肷
                    m_fFixed = true;
                    m_fSpecialExtending = false;
                }
                else if (!m_fSpecialExtending && fileSize == m_fileSize) {
                    // L΂߂
                    if (!m_fFixed) m_duration -= RENEW_SIZE_INTERVAL;
                    m_fFixed = true;
                }
                else {
                    m_fFixed = false;
                }
                m_fileSize = fileSize;
            }
            m_renewSizeTick = tick;
        }
        if (!m_fFixed) m_duration += tick - m_renewDurTick;
        m_renewDurTick = tick;
    }

    if (m_fPause) return true;

    // pPbg̓ǂݍ݂Ɠ]
    for (bool fSent = false; !fSent;) {
        if (!ReadPacket()) {
            ConsumeBuffer(true);
            if (!ReadPacket()) return false;
            fSent = true;
        }
        // ][g
        if (m_fPcr) {
            DWORD tickDiff = GetAdjTickCount() - m_baseTick;

            DWORD pcrDiff = m_pcr - m_basePcr;
            if (MSB(pcrDiff)) pcrDiff = 0;

            // Đxオ=PCR̐isxȂ
            int msec = (int)((long long)pcrDiff * m_speedDen / m_speedNum / PCR_PER_MSEC) - tickDiff;

            // 䂵Ȃꍇ͈xZbg
            if (msec < -2000 || 2000 * m_speedDen / m_speedNum < msec) {
                // PCRݒ(M̃XgA𑝂₷ߏ)
                m_baseTick = GetAdjTickCount() - m_initStore;
                m_basePcr = m_pcr;
            }
            else if (msec > 0) ::Sleep(msec);
        }
    }
    return true;
}


// t@C̐擪ɃV[N
bool CTsSender::SeekToBegin()
{
    return Seek(0, FILE_BEGIN);
}


// t@C̖2bOɃV[N
bool CTsSender::SeekToEnd()
{
    return m_fSpecialExtending ? false : Seek(-GetRate()*2, FILE_END);
}


// ݂̍ĐʒumsecV[N
// ݂̍Đʒus̏ꍇSeekToBegin()
// V[N\͈͂𒴂orꍇ͐擪or̖2bO܂ŃV[N
// V[NłȂorV[Nł؂ꂽƂfalseԂ
bool CTsSender::Seek(int msec)
{
    if (!m_pcrCount) return SeekToBegin();

    long long rate = (long long)GetRate();
    long long size = GetFileSize();
    long long pos;

    if (size < 0) return false;

    // -5000<=msec<=5000ɂȂ܂œ惌[gTZV[N
    // 5[v܂łɎȂΎs
    for (int i = 0; i < 5 && (msec < -5000 || 5000 < msec); i++) {
        if ((pos = GetFilePosition()) < 0) return false;

        // OorɂȏV[NłȂꍇ
        if (msec < 0 && pos <= rate ||
            msec > 0 && pos >= size - rate*2) return true;

        long long approx = pos + rate * msec / 1000;
        if (approx > size - rate*2) approx = size - rate*2;
        if (approx < 0) approx = 0;

        DWORD prevPcr = m_pcr;
        if (!Seek(approx, FILE_BEGIN) || !m_pcrCount) return false;

        // ړ
        msec += MSB(m_pcr-prevPcr) ? (int)(prevPcr-m_pcr) / PCR_PER_MSEC :
                                    -(int)(m_pcr-prevPcr) / PCR_PER_MSEC;
    }
    if (!m_pcrCount || msec < -5000 || 5000 < msec) return false;

    if (msec < 0) {
        // 1bOV[N
        // 10[v܂łɎȂΎs
        for (int i = 0; i < 10 && msec < -500; i++) {
            if ((pos = GetFilePosition()) < 0) return false;
            if (pos <= rate) return true;

            DWORD prevPcr = m_pcr;
            if (!Seek(-rate, FILE_CURRENT) || !m_pcrCount || MSB(prevPcr-m_pcr)) return false;
            msec += (int)(prevPcr-m_pcr) / PCR_PER_MSEC;
        }
        if (msec < -500) return false;
    }
    else {
        // 1bV[N
        // 10[v܂łɎȂΎs
        for (int i = 0; i < 10 && msec > 500; i++) {
            if ((pos = GetFilePosition()) < 0) return false;
            if (pos >= size - rate*2) return true;

            DWORD prevPcr = m_pcr;
            if (!Seek(rate, FILE_CURRENT) || !m_pcrCount || MSB(m_pcr-prevPcr)) return false;
            msec -= (int)(m_pcr-prevPcr) / PCR_PER_MSEC;
        }
        if (msec > 500) return false;
    }
    return true;
}


void CTsSender::Pause(bool fPause)
{
    if (m_fPause && !fPause) {
        // PCRݒ(M̃XgA𑝂₷ߏ)
        m_baseTick = GetAdjTickCount() - m_initStore;
        m_basePcr = m_pcr;
    }
    m_fPause = fPause;
}


// ɑ΂Đx𕪎qŎw
// 0ȉ̒l^Ă͂Ȃ
void CTsSender::SetSpeed(int num, int den)
{
    m_speedNum = num;
    m_speedDen = den;
    m_initStore = min(INITIAL_STORE_MSEC * den / num, INITIAL_STORE_MSEC);
    // PCRݒ
    m_baseTick = GetAdjTickCount();
    m_basePcr = m_pcr;
}


// ݂̃t@CTCY擾
long long CTsSender::GetFileSize() const
{
    LARGE_INTEGER liFileSize;
    if (m_hFile && ::GetFileSizeEx(m_hFile, &liFileSize)) {
        return liFileSize.QuadPart;
    }
    return -1;
}


// ݂̃t@C|C^̈ʒu擾
long long CTsSender::GetFilePosition() const
{
    LARGE_INTEGER liNew, liMove = {0};
    if (m_hFile && ::SetFilePointerEx(m_hFile, liMove, &liNew, FILE_CURRENT)) {
        return liNew.QuadPart;
    }
    return -1;
}


// ̒(~b)擾
// młȂꍇ
// t@CTCYg咆̏ꍇ͓ł̑
int CTsSender::GetDuration() const
{
    return m_duration < 0 ? 0 : m_duration;
}


// ̍Đʒu(~b)擾
int CTsSender::GetPosition() const
{
    return !m_pcrCount ? 0 : (m_pcr - m_initPcr) / PCR_PER_MSEC;
}


// TOTtZ̕(~b)擾
// 擾s͕Ԃ
int CTsSender::GetBroadcastTime() const
{
    if (m_totBase < 0) return -1;

    int totInit = m_totBase - (int)((m_totBasePcr - m_initPcr) / PCR_PER_MSEC);
    if (totInit < 0) totInit += 24 * 3600000; // 1
    return totInit;
}


// Ŝ̃[g(Bytes/b)擾
// młȂꍇ
// ɒ[Ȓl͗}
int CTsSender::GetRate() const
{
    int rate;
    if (m_fSpecialExtending) {
        rate = m_specialExtendInitRate;
    }
    else {
        long long fileSize = GetFileSize();
        rate = fileSize < 0 || m_duration <= 0 ? TS_SUPPOSED_RATE :
               static_cast<int>(fileSize * 1000 / m_duration);
    }
    return rate < TS_SUPPOSED_RATE/128 ? TS_SUPPOSED_RATE/128 :
           rate > TS_SUPPOSED_RATE*4 ? TS_SUPPOSED_RATE*4 : rate;
}


// ␳ς݂TickJEg擾
DWORD CTsSender::GetAdjTickCount()
{
    DWORD tick = ::GetTickCount();
    if (m_adjState != 2) return tick;

    if (!m_adjDelta) {
        if (tick - m_adjHoldTick >= ADJUST_TICK_INTERVAL) {
            LARGE_INTEGER liNow;
            if (::QueryPerformanceCounter(&liNow)) {
                LONGLONG llDiff = (liNow.QuadPart - m_liAdjBase.QuadPart) * 1000 / m_liAdjFreq.QuadPart;
                m_adjDelta = (static_cast<DWORD>(llDiff) - (tick - m_adjBaseTick)) - m_adjAmount;
            }
            m_adjHoldTick = tick;
        }
    }
    if (m_adjDelta) {
        // ߂h~
        if (!MSB(tick + m_adjDelta - m_adjHoldTick)) {
            m_adjAmount += m_adjDelta;
            m_adjDelta = 0;
        }
    }
    DWORD adjTick = (m_adjDelta ? m_adjHoldTick : tick) + m_adjAmount;
#if 0
    static DWORD last;
    // 2ڈȍ~Open()ɂ͕KȂ
    ASSERT(!last || !MSB(adjTick - last));
    last = adjTick;
#endif
    return adjTick;
}


// t@C擪56bitnbVl擾
long long CTsSender::GetFileHash() const
{
    return m_hash;
}


// TSpPbg1ǂ
bool CTsSender::ReadPacket(int count)
{
    if (!m_hFile || !m_pBuf || count <= 0) return false;

    if (m_curr + m_unitSize >= m_tail) {
        int n = static_cast<int>(m_pBuf + m_unitSize * BUFFER_LEN - m_tail);
        if (n > 0) {
            DWORD readBytes;
            if (!::ReadFile(m_hFile, m_tail, n, &readBytes, NULL)) return false;
            m_tail += readBytes;
        }
    }

    // obt@TSpPbgǂ߂邾̃f[^Ȃ
    if (m_curr + m_unitSize >= m_tail) return false;

    if (m_curr[0] != 0x47 || m_curr[m_unitSize] != 0x47) {
        BYTE *p = resync(m_curr, m_tail, m_unitSize);
        if (!p) {
            m_curr = m_tail = m_pBuf;
            // sȃpPbg΃JEg͌Ă
            return ReadPacket(count - 1);
        }
        m_curr = p;
        if (m_curr + m_unitSize > m_tail) return ReadPacket(count - 1);
    }

    m_fPcr = false;

    TS_HEADER header;
    extract_ts_header(&header, m_curr);

    if (header.adaptation_field_control & 2 &&
        !header.transport_error_indicator)
    {
        // A_ve[VtB[h
        ADAPTATION_FIELD adapt;
        extract_adaptation_field(&adapt, m_curr + 4);

        if (adapt.pcr_flag) {
            // QPID܂ĂȂƂAŏ3PCRoPIDQPIDƂ
            // QPIDPCR邱ƂȂ3ʂPCRo΁AQPIDύX
            if (header.pid != m_pcrPid) {
                bool fFound = false;
                for (int i = 0; i < m_pcrPidsLen; i++) {
                    if (m_pcrPids[i] == header.pid) {
                        if (++m_pcrPidCounts[i] >= 3) m_pcrPid = header.pid;
                        fFound = true;
                        break;
                    }
                }
                if (!fFound && m_pcrPidsLen < PCR_PIDS_MAX) {
                    m_pcrPids[m_pcrPidsLen] = header.pid;
                    m_pcrPidCounts[m_pcrPidsLen] = 1;
                    m_pcrPidsLen++;
                }
            }

            // QPID̂ƂPCR擾
            if (header.pid == m_pcrPid) {
                m_pcrPidsLen = 0;
                m_pcr = (DWORD)adapt.pcr_45khz;

                if (m_pcrCount++ == 0) {
                    // PCRݒ(M̃XgA𑝂₷ߏ)
                    m_baseTick = GetAdjTickCount() - m_initStore;
                    m_basePcr = m_pcr;
                }
                m_fPcr = true;
            }
        }
    }

    if (header.pid == 0x14 && m_pcrCount &&
        !header.transport_error_indicator &&
        header.payload_unit_start_indicator &&
        header.adaptation_field_control == 1)
    {
        // TOT-PCRΉ擾
        int pointerField = m_curr[4];
        BYTE *pTable = m_curr + 5 + pointerField;
        if (pTable + 7 < m_curr + 188 && (pTable[0] == 0x73 || pTable[0] == 0x70)) {
            // BCD(ARIB STD-B10)
            m_totBase = ((pTable[5]>>4)*10 + (pTable[5]&0x0f)) * 3600000 +
                        ((pTable[6]>>4)*10 + (pTable[6]&0x0f)) * 60000 +
                        ((pTable[7]>>4)*10 + (pTable[7]&0x0f)) * 1000;
            m_totBasePcr = m_pcr;
        }
    }

    m_curr += m_unitSize;
    return true;
}


// ǂݍ܂ꂽTSpPbg]E
void CTsSender::ConsumeBuffer(bool fSend)
{
    if (!m_pBuf) return;

    if (fSend && m_curr > m_pBuf) {
        if (m_fTrimPacket) {
            // ]镔188BytePʂɋl߂
            BYTE *p = m_pBuf;
            BYTE *q = m_pBuf;
            while (p <= m_curr - m_unitSize) {
                memmove(q, p, 188);
                p += m_unitSize;
                q += 188;
            }
            memmove(q, p, m_tail - p);
            m_curr -= p - q;
            m_tail -= p - q;
        }

        if (m_udpAddr[0]) {
            if (!m_sock) OpenSocket();
            if (m_sock) {
                // UDP]
                sockaddr_in addr = {0};
                addr.sin_family = AF_INET;
                addr.sin_port = htons(m_udpPort);
                addr.sin_addr.S_un.S_addr = inet_addr(m_udpAddr);
                if (::sendto(m_sock, (const char*)m_pBuf, (int)(m_curr - m_pBuf),
                             0, (sockaddr*)&addr, sizeof(addr)) == SOCKET_ERROR)
                {
                    CloseSocket();
                }
            }
        }
        if (m_pipeName[0]) {
            if (!m_hPipe) OpenPipe();
            if (m_hPipe) {
                // pCv]
                DWORD written;
                if (!::WriteFile(m_hPipe, m_pBuf, (DWORD)(m_curr - m_pBuf), &written, NULL)) {
                    ClosePipe();
                }
            }
        }
    }
    int n = static_cast<int>(m_tail - m_curr);
    if (n > 0) memcpy(m_pBuf, m_curr, n);

    m_curr = m_pBuf;
    m_tail = m_pBuf + n;
}


// V[N
// V[NA\Ȃ΍ŏPCR̈ʒu܂œǂ܂
bool CTsSender::Seek(long long distanceToMove, DWORD dwMoveMethod)
{
    if (!m_hFile) return false;

    LARGE_INTEGER lDistanceToMove;
    lDistanceToMove.QuadPart = distanceToMove;
    if (!::SetFilePointerEx(m_hFile, lDistanceToMove, NULL, dwMoveMethod)) return false;

    // V[N̓obt@ɂ
    m_curr = m_tail = m_pBuf;
    m_pcrCount = 0;
    for (int i = 0; i < 20000 && !m_pcrCount; i++) {
        if (!ReadPacket()) {
            ConsumeBuffer(false);
            if (!ReadPacket()) break;
        }
    }

    return true;
}


// t@CTSf[^݂鋫ڂ܂ŃV[N
// log2(t@CTCY/TS_SUPPOSED_RATE)񂮂炢ċA
bool CTsSender::SeekToBoundary(long long predicted, long long range, LPBYTE pWork, int workSize)
{
    if (!m_hFile) return false;

    LARGE_INTEGER lDistanceToMove;
    lDistanceToMove.QuadPart = predicted;
    if (!::SetFilePointerEx(m_hFile, lDistanceToMove, NULL, FILE_BEGIN)) return false;

    if (range < TS_SUPPOSED_RATE) return true;

    DWORD readBytes;
    if (!::ReadFile(m_hFile, pWork, workSize, &readBytes, NULL)) return false;
    int unitSize = select_unit_size(pWork, pWork + readBytes);

    ::Sleep(20); // fBXNւ̎v
    return SeekToBoundary(predicted + (unitSize < 188 ? -range/4 : range/4), range/2, pWork, workSize);
}


void CTsSender::OpenSocket()
{
    CloseSocket();

    WSADATA wsaData;
    if (::WSAStartup(MAKEWORD(2,0), &wsaData) == 0) {
        m_sock = ::socket(AF_INET, SOCK_DGRAM, 0);
        if (m_sock == INVALID_SOCKET) {
            m_sock = NULL;
            ::WSACleanup();
        }
    }
}


void CTsSender::CloseSocket()
{
    if (m_sock) {
        ::closesocket(m_sock);
        m_sock = NULL;
        ::WSACleanup();
    }
}


void CTsSender::OpenPipe()
{
    if (!m_pipeName[0]) return;
    ClosePipe();

    if (::WaitNamedPipe(m_pipeName, NMPWAIT_USE_DEFAULT_WAIT)) {
        m_hPipe = ::CreateFile(m_pipeName, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
        if (m_hPipe == INVALID_HANDLE_VALUE) {
            m_hPipe = NULL;
        }
    }
}


void CTsSender::ClosePipe()
{
    if (m_hPipe) {
        ::CloseHandle(m_hPipe);
        m_hPipe = NULL;
    }
}
