// TVTesttst@CĐ@\ǉvOC
// ŏIXV: 2012-02-17
// : 849fa586809b0d16276cd644c6749503
#include <Windows.h>
#include <WindowsX.h>
#include <Shlwapi.h>
#include <list>
#include "Util.h"
#include "Settings.h"
#include "ColorScheme.h"
#include "StatusView.h"
#include "TsSender.h"
#include "resource.h"
#define TVTEST_PLUGIN_CLASS_IMPLEMENT
#define TVTEST_PLUGIN_VERSION TVTEST_PLUGIN_VERSION_(0,0,13)
#include "TVTestPlugin.h"
#include "TvtPlay.h"

static LPCWSTR INFO_PLUGIN_NAME = L"TvtPlay";
static LPCWSTR INFO_DESCRIPTION = L"t@CĐ@\ǉ (ver.0.9r8)";

#define WM_UPDATE_POSITION  (WM_APP + 1)
#define WM_UPDATE_TOT_TIME  (WM_APP + 2)
#define WM_UPDATE_F_PAUSED  (WM_APP + 3)
#define WM_UPDATE_SPEED     (WM_APP + 4)
#define WM_QUERY_CLOSE      (WM_APP + 5)
#define WM_QUERY_SEEK_BGN   (WM_APP + 6)
#define WM_QUERY_RESET      (WM_APP + 7)

#define WM_TS_SET_UDP       (WM_APP + 1)
#define WM_TS_SET_PIPE      (WM_APP + 2)
#define WM_TS_PAUSE         (WM_APP + 3)
#define WM_TS_SEEK_BGN      (WM_APP + 4)
#define WM_TS_SEEK_END      (WM_APP + 5)
#define WM_TS_SEEK          (WM_APP + 6)
#define WM_TS_SET_SPEED     (WM_APP + 7)

static LPCTSTR SETTINGS = TEXT("Settings");
static LPCTSTR TVTPLAY_FRAME_WINDOW_CLASS = TEXT("TvtPlay Frame");
static LPCSTR UDP_ADDR = "127.0.0.1";
static LPCTSTR PIPE_NAME = TEXT("\\\\.\\pipe\\BonDriver_Pipe%02d");

enum {
    ID_COMMAND_OPEN,
    ID_COMMAND_OPEN_POPUP,
    ID_COMMAND_CLOSE,
    ID_COMMAND_SEEK_BGN,
    ID_COMMAND_SEEK_END,
    ID_COMMAND_LOOP,
    ID_COMMAND_PAUSE,
    ID_COMMAND_NOP,
    ID_COMMAND_SEEK_A,
    ID_COMMAND_SEEK_B,
    ID_COMMAND_SEEK_C,
    ID_COMMAND_SEEK_D,
    ID_COMMAND_SEEK_E,
    ID_COMMAND_SEEK_F,
    ID_COMMAND_SEEK_G,
    ID_COMMAND_SEEK_H,
    ID_COMMAND_STRETCH_A,
    ID_COMMAND_STRETCH_B,
    ID_COMMAND_STRETCH_C,
    ID_COMMAND_STRETCH_D,
};

static const TVTest::CommandInfo COMMAND_LIST[] = {
    {ID_COMMAND_OPEN, L"Open", L"t@CJ"},
    {ID_COMMAND_OPEN_POPUP, L"OpenPopup", L"t@CJ(|bvAbv)"},
    {ID_COMMAND_CLOSE, L"Close", L"t@C"},
    {ID_COMMAND_SEEK_BGN, L"SeekToBgn", L"V[N:擪"},
    {ID_COMMAND_SEEK_END, L"SeekToEnd", L"V[N:"},
    {ID_COMMAND_LOOP, L"Loop", L"[v/Ȃ"},
    {ID_COMMAND_PAUSE, L"Pause", L"ꎞ~/Đ"},
    {ID_COMMAND_NOP, L"Nop", L"Ȃ"},
    {ID_COMMAND_SEEK_A, L"SeekA", L"V[N:A"},
    {ID_COMMAND_SEEK_B, L"SeekB", L"V[N:B"},
    {ID_COMMAND_SEEK_C, L"SeekC", L"V[N:C"},
    {ID_COMMAND_SEEK_D, L"SeekD", L"V[N:D"},
    {ID_COMMAND_SEEK_E, L"SeekE", L"V[N:E"},
    {ID_COMMAND_SEEK_F, L"SeekF", L"V[N:F"},
    {ID_COMMAND_SEEK_G, L"SeekG", L"V[N:G"},
    {ID_COMMAND_SEEK_H, L"SeekH", L"V[N:H"},
    {ID_COMMAND_STRETCH_A, L"StretchA", L":A"},
    {ID_COMMAND_STRETCH_B, L"StretchB", L":B"},
    {ID_COMMAND_STRETCH_C, L"StretchC", L":C"},
    {ID_COMMAND_STRETCH_D, L"StretchD", L":D"},
};

static const int DEFAULT_SEEK_LIST[COMMAND_SEEK_MAX] = {
    -60000, -30000, -15000, -5000, 4000, 14000, 29000, 59000
};

static const int DEFAULT_STRETCH_LIST[COMMAND_STRETCH_MAX] = {
    400, 200, 50, 25
};

// NULL֎~
static LPCTSTR DEFAULT_BUTTON_LIST[BUTTON_MAX] = {
    TEXT("0,Open"), TEXT(";1,Close"), TEXT(";4,Loop"),
    TEXT(";2,SeekToBgn"),
    TEXT("'-'6'0,SeekA"), TEXT(";'-'3'0,SeekB"),
    TEXT("'-'1'5,SeekC"), TEXT("'-' '5,SeekD"),
    TEXT("6,Pause"),
    TEXT("'+' '5,SeekE"), TEXT("'+'1'5,SeekF"),
    TEXT(";'+'3'0,SeekG"), TEXT("'+'6'0,SeekH"),
    TEXT("3,SeekToEnd"),
    TEXT("'*'2'.'0:30~'*'2'.'0,StretchB"),
    TEXT("'*'0'.'5:30~'*'0'.'5,StretchC")
};


CTvtPlay::CTvtPlay()
    : m_fInitialized(false)
    , m_fSettingsLoaded(false)
    , m_fForceEnable(false)
    , m_fIgnoreExt(false)
    , m_fAutoEnUdp(false)
    , m_fAutoEnPipe(false)
    , m_fEventExecute(false)
    , m_fRaisePriority(false)
    , m_hwndFrame(NULL)
    , m_fFullScreen(false)
    , m_fHide(false)
    , m_fToBottom(false)
    , m_statusMargin(0)
    , m_fSeekDrawTot(false)
    , m_fPosDrawTot(false)
    , m_posItemWidth(0)
    , m_timeoutOnCmd(0)
    , m_timeoutOnMove(0)
    , m_dispCount(0)
    , m_lastDropCount(0)
    , m_resetDropInterval(0)
    , m_buttonNum(0)
    , m_popupMax(0)
    , m_fPopupDesc(false)
    , m_fPopuping(false)
    , m_hThread(NULL)
    , m_hThreadEvent(NULL)
    , m_threadID(0)
    , m_threadPriority(THREAD_PRIORITY_NORMAL)
    , m_position(0)
    , m_duration(0)
    , m_totTime(-1)
    , m_speed(100)
    , m_fFixed(false)
    , m_fSpecialExt(false)
    , m_fPaused(false)
    , m_fHalt(false)
    , m_fAutoClose(false)
    , m_fAutoLoop(false)
    , m_fResetAllOnSeek(false)
    , m_stretchMode(0)
    , m_noMuteMax(0)
    , m_noMuteMin(0)
    , m_fConvTo188(false)
    , m_fUseQpc(false)
    , m_salt(0)
    , m_hashListMax(0)
{
    m_szIniFileName[0] = 0;
    m_szSpecFileName[0] = 0;
    m_szIconFileName[0] = 0;
    m_szPopupPattern[0] = 0;
    m_szPrevFileName[0] = 0;
    CStatusView::Initialize(g_hinstDLL);
}


bool CTvtPlay::GetPluginInfo(TVTest::PluginInfo *pInfo)
{
    // vOC̏Ԃ
    pInfo->Type           = TVTest::PLUGIN_TYPE_NORMAL;
    pInfo->Flags          = TVTest::PLUGIN_FLAG_DISABLEONSTART;
    pInfo->pszPluginName  = INFO_PLUGIN_NAME;
    pInfo->pszCopyright   = L"Public Domain";
    pInfo->pszDescription = INFO_DESCRIPTION;
    return true;
}


void CTvtPlay::AnalyzeCommandLine(LPCWSTR cmdLine, bool fIgnoreFirst)
{
    m_szSpecFileName[0] = 0;

    int argc;
    LPTSTR *argv = ::CommandLineToArgvW(cmdLine, &argc);
    if (argv) {
        for (int i = fIgnoreFirst; i < argc; ++i) {
            // IvV͕N֎~ɖ->Lɂ邱Ƃł
            if (argv[i][0] == TEXT('/') || argv[i][0] == TEXT('-')) {
                if (!::lstrcmpi(argv[i]+1, TEXT("tvtplay"))) m_fForceEnable = m_fIgnoreExt = true;
                else if (!::lstrcmpi(argv[i]+1, TEXT("tvtpudp"))) m_fAutoEnUdp = true;
                else if (!::lstrcmpi(argv[i]+1, TEXT("tvtpipe"))) m_fAutoEnPipe = true;
            }
        }

        if (argc >= 1 + fIgnoreFirst && argv[argc-1][0] != TEXT('/') && argv[argc-1][0] != TEXT('-')) {
            bool fSpec = m_fIgnoreExt;
            if (!m_fIgnoreExt) {
                LPCTSTR ext = ::PathFindExtension(argv[argc-1]);
                if (ext && (!::lstrcmpi(ext, TEXT(".ts")) ||
                            !::lstrcmpi(ext, TEXT(".m2t")) ||
                            !::lstrcmpi(ext, TEXT(".m2ts"))))
                {
                    m_fForceEnable = true;
                    fSpec = true;
                }
            }
            if (fSpec) ::lstrcpyn(m_szSpecFileName, argv[argc-1], ARRAY_SIZE(m_szSpecFileName));
        }

        ::LocalFree(argv);
    }
}


// 
bool CTvtPlay::Initialize()
{
    // R}ho^
    m_pApp->RegisterCommand(COMMAND_LIST, ARRAY_SIZE(COMMAND_LIST));

    // CxgR[obN֐o^
    m_pApp->SetEventCallback(EventCallback, this);

    AnalyzeCommandLine(::GetCommandLine(), true);
    if (m_fForceEnable) m_pApp->EnablePlugin(true);

    return true;
}


// I
bool CTvtPlay::Finalize()
{
    if (m_pApp->IsPluginEnabled()) EnablePlugin(false);
    return true;
}


// ݒ̓ǂݍ
void CTvtPlay::LoadSettings()
{
    if (m_fSettingsLoaded) return;

    if (!::GetModuleFileName(g_hinstDLL, m_szIniFileName, ARRAY_SIZE(m_szIniFileName)) ||
        !::PathRenameExtension(m_szIniFileName, TEXT(".ini"))) m_szIniFileName[0] = 0;

    int defMargin = m_pApp->GetVersion() >= TVTest::MakeVersion(0,7,21) ? 1 : 2; // 0.7.21ȍ~ׂ͍Ȃ
    int defSalt = (::GetTickCount()>>16)^(::GetTickCount()&0xffff);

    m_fAutoClose = ::GetPrivateProfileInt(SETTINGS, TEXT("TsAutoClose"), 0, m_szIniFileName) != 0;
    m_fAutoLoop = ::GetPrivateProfileInt(SETTINGS, TEXT("TsAutoLoop"), 0, m_szIniFileName) != 0;
    m_fResetAllOnSeek = ::GetPrivateProfileInt(SETTINGS, TEXT("TsResetAllOnSeek"), 0, m_szIniFileName) != 0;
    m_resetDropInterval = ::GetPrivateProfileInt(SETTINGS, TEXT("TsResetDropInterval"), 1000, m_szIniFileName);
    m_threadPriority = ::GetPrivateProfileInt(SETTINGS, TEXT("TsThreadPriority"), THREAD_PRIORITY_NORMAL, m_szIniFileName);
    m_stretchMode = ::GetPrivateProfileInt(SETTINGS, TEXT("TsStretchMode"), 3, m_szIniFileName);
    m_noMuteMax = ::GetPrivateProfileInt(SETTINGS, TEXT("TsStretchNoMuteMax"), 800, m_szIniFileName);
    m_noMuteMin = ::GetPrivateProfileInt(SETTINGS, TEXT("TsStretchNoMuteMin"), 50, m_szIniFileName);
    m_fConvTo188 = ::GetPrivateProfileInt(SETTINGS, TEXT("TsConvTo188"), 1, m_szIniFileName) != 0;
    m_fUseQpc = ::GetPrivateProfileInt(SETTINGS, TEXT("TsUsePerfCounter"), 1, m_szIniFileName) != 0;
    m_fRaisePriority = ::GetPrivateProfileInt(SETTINGS, TEXT("RaiseMainThreadPriority"), 0, m_szIniFileName) != 0;
    m_fToBottom = ::GetPrivateProfileInt(SETTINGS, TEXT("ToBottom"), 1, m_szIniFileName) != 0;
    m_statusMargin = ::GetPrivateProfileInt(SETTINGS, TEXT("Margin"), defMargin, m_szIniFileName);
    m_fSeekDrawTot = ::GetPrivateProfileInt(SETTINGS, TEXT("DispTot"), 0, m_szIniFileName) != 0;
    m_fPosDrawTot = ::GetPrivateProfileInt(SETTINGS, TEXT("DispTotOnStatus"), 0, m_szIniFileName) != 0;
    m_posItemWidth = ::GetPrivateProfileInt(SETTINGS, TEXT("StatusItemWidth"), 112, m_szIniFileName);
    m_timeoutOnCmd = ::GetPrivateProfileInt(SETTINGS, TEXT("TimeoutOnCommand"), 2000, m_szIniFileName);
    m_timeoutOnMove = ::GetPrivateProfileInt(SETTINGS, TEXT("TimeoutOnMouseMove"), 0, m_szIniFileName);
    m_salt = ::GetPrivateProfileInt(SETTINGS, TEXT("Salt"), defSalt, m_szIniFileName);
    m_hashListMax = ::GetPrivateProfileInt(SETTINGS, TEXT("FileInfoMax"), 0, m_szIniFileName);
    m_hashListMax = min(m_hashListMax, HASH_LIST_MAX_MAX);
    m_popupMax = ::GetPrivateProfileInt(SETTINGS, TEXT("PopupMax"), 30, m_szIniFileName);
    m_popupMax = min(m_popupMax, POPUP_MAX_MAX);
    m_fPopupDesc = ::GetPrivateProfileInt(SETTINGS, TEXT("PopupDesc"), 0, m_szIniFileName) != 0;

    ::GetPrivateProfileString(SETTINGS, TEXT("PopupPattern"), TEXT("%RecordFolder%*.ts"),
                              m_szPopupPattern, ARRAY_SIZE(m_szPopupPattern), m_szIniFileName);

    ::GetPrivateProfileString(SETTINGS, TEXT("IconImage"), TEXT(""),
                              m_szIconFileName, ARRAY_SIZE(m_szIconFileName), m_szIniFileName);

    // V[NR}h̃V[Nʐݒ擾
    for (int i = 0; i < COMMAND_SEEK_MAX; i++) {
        TCHAR key[16];
        ::wsprintf(key, TEXT("Seek%c"), (TCHAR)i + TEXT('A'));
        m_seekList[i] = ::GetPrivateProfileInt(SETTINGS, key, DEFAULT_SEEK_LIST[i], m_szIniFileName);
    }

    // R}h̔{(25%`800%)ݒ擾
    for (int i = 0; i < COMMAND_STRETCH_MAX; i++) {
        TCHAR key[16];
        ::wsprintf(key, TEXT("Stretch%c"), (TCHAR)i + TEXT('A'));
        int r = ::GetPrivateProfileInt(SETTINGS, key, DEFAULT_STRETCH_LIST[i], m_szIniFileName);
        m_stretchList[i] = min(max(r, 25), 800);
    }

    // {^ACe̔zuݒ擾
    for (int i = 0; i < BUTTON_MAX; i++) {
        TCHAR key[16];
        ::wsprintf(key, TEXT("Button%02d"), i);
        ::GetPrivateProfileString(SETTINGS, key, DEFAULT_BUTTON_LIST[i],
                                  m_buttonList[i], ARRAY_SIZE(m_buttonList[0]), m_szIniFileName);
    }

    // t@CŗL̃W[Ȃǂ擾
    // L[ԍ̂قǐV
    m_hashList.clear();
    if (m_hashListMax > 0) {
        // FileInfoZNV͈Cɓǂݍ
        // strɂm_hashListMax̃L[i[ł΂悢
        LPTSTR str = new TCHAR[m_hashListMax * 96];
        DWORD read = ::GetPrivateProfileSection(TEXT("FileInfo"), str, m_hashListMax * 96, m_szIniFileName);
        if (read > 0) {
            LPCTSTR p = str;
            for (int i = 0; i < m_hashListMax; i++) {
                TCHAR key[32];
                int keyLen;
                HASH_INFO hashInfo;

                keyLen = ::wsprintf(key, TEXT("Hash%d="), i);
                while (*p && ::StrCmpNI(p, key, keyLen)) p += ::lstrlen(p) + 1;
                if (!*p) break;
                if (!::StrToInt64Ex(p + keyLen, STIF_SUPPORT_HEX, &hashInfo.hash)) continue;

                keyLen = ::wsprintf(key, TEXT("Resume%d="), i);
                while (*p && ::StrCmpNI(p, key, keyLen)) p += ::lstrlen(p) + 1;
                if (!*p) break;
                hashInfo.resumePos = ::StrToInt(p + keyLen);

                m_hashList.push_back(hashInfo);
            }
        }
        delete [] str;
    }

    m_fSettingsLoaded = true;

    // ftHg̐ݒL[o͂邽
    if (::GetPrivateProfileInt(SETTINGS, TEXT("TsUsePerfCounter"), -1, m_szIniFileName) == -1)
        SaveSettings();

    CColorScheme scheme;
    TCHAR val[2];
    ::GetPrivateProfileString(TEXT("ColorScheme"), TEXT("Name"), TEXT("!"), val, ARRAY_SIZE(val), m_szIniFileName);
    if (val[0] != TEXT('!')) {
        // ColorSchemeZNV΃vOCinig({̎dlύXւ̕ی)
        scheme.Load(m_szIniFileName);
    }
    else {
        TVTest::HostInfo hostInfo;
        WCHAR szAppIniPath[MAX_PATH];
        if (m_pApp->GetHostInfo(&hostInfo) &&
            m_pApp->GetSetting(L"IniFilePath", szAppIniPath, MAX_PATH) > 0)
        {
            // Mutex𐶐
            WCHAR szMutexName[64+MAX_PATH];
            ::lstrcpyn(szMutexName, hostInfo.pszAppName, 48);
            ::lstrcat(szMutexName, L"_Ini_Mutex_");
            ::lstrcat(szMutexName, szAppIniPath);
            for (WCHAR *p = szMutexName; *p; ++p)
                if (*p == L'\\') *p = L':';

            // inibN(łȂΒr[ɓǂݍ݂ɂȂ)
            CGlobalLock fileLock;
            if (fileLock.Create(szMutexName)) {
                if (fileLock.Wait(5000)) {
                    scheme.Load(szAppIniPath);
                    fileLock.Release();
                }
                fileLock.Close();
            }
        }
    }

    // zF
    CStatusView::ThemeInfo theme;
    scheme.GetStyle(CColorScheme::STYLE_STATUSITEM, &theme.ItemStyle);
    scheme.GetStyle(CColorScheme::STYLE_STATUSBOTTOMITEM, &theme.BottomItemStyle);
    scheme.GetStyle(CColorScheme::STYLE_STATUSHIGHLIGHTITEM, &theme.HighlightItemStyle);
    scheme.GetBorderInfo(CColorScheme::BORDER_STATUS, &theme.Border);
    m_statusView.SetTheme(&theme);
}


// ݒ̕ۑ
void CTvtPlay::SaveSettings() const
{
    if (!m_fSettingsLoaded) return;

    WritePrivateProfileInt(SETTINGS, TEXT("TsAutoClose"), m_fAutoClose, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TsAutoLoop"), m_fAutoLoop, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TsResetAllOnSeek"), m_fResetAllOnSeek, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TsResetDropInterval"), m_resetDropInterval, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TsThreadPriority"), m_threadPriority, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TsStretchMode"), m_stretchMode, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TsStretchNoMuteMax"), m_noMuteMax, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TsStretchNoMuteMin"), m_noMuteMin, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TsConvTo188"), m_fConvTo188, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TsUsePerfCounter"), m_fUseQpc, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("RaiseMainThreadPriority"), m_fRaisePriority, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("ToBottom"), m_fToBottom, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("Margin"), m_statusMargin, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("DispTot"), m_fSeekDrawTot, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("DispTotOnStatus"), m_fPosDrawTot, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("StatusItemWidth"), m_posItemWidth, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TimeoutOnCommand"), m_timeoutOnCmd, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("TimeoutOnMouseMove"), m_timeoutOnMove, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("Salt"), m_salt, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("FileInfoMax"), m_hashListMax, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("PopupMax"), m_popupMax, m_szIniFileName);
    WritePrivateProfileInt(SETTINGS, TEXT("PopupDesc"), m_fPopupDesc, m_szIniFileName);
    ::WritePrivateProfileString(SETTINGS, TEXT("PopupPattern"), m_szPopupPattern, m_szIniFileName);
    ::WritePrivateProfileString(SETTINGS, TEXT("IconImage"), m_szIconFileName, m_szIniFileName);

    for (int i = 0; i < COMMAND_SEEK_MAX; i++) {
        TCHAR key[16];
        ::wsprintf(key, TEXT("Seek%c"), (TCHAR)i + TEXT('A'));
        WritePrivateProfileInt(SETTINGS, key, m_seekList[i], m_szIniFileName);
    }

    for (int i = 0; i < COMMAND_STRETCH_MAX; i++) {
        TCHAR key[16];
        ::wsprintf(key, TEXT("Stretch%c"), (TCHAR)i + TEXT('A'));
        WritePrivateProfileInt(SETTINGS, key, m_stretchList[i], m_szIniFileName);
    }

    for (int i = 0; i < BUTTON_MAX; i++) {
        TCHAR key[16];
        ::wsprintf(key, TEXT("Button%02d"), i);
        ::WritePrivateProfileString(SETTINGS, key, m_buttonList[i], m_szIniFileName);
    }

    // FileInfoZNV͈Cɏ
    LPTSTR str = new TCHAR[2 + m_hashList.size() * 96];
    LPTSTR tail = str;
    tail[0] = tail[1] = 0;
    std::list<HASH_INFO>::const_iterator it = m_hashList.begin();
    for (int i = 0; it != m_hashList.end(); i++, it++) {
        tail += ::wsprintf(tail, TEXT("Hash%d=0x%06x%08x"), i, (DWORD)((*it).hash>>32), (DWORD)((*it).hash)) + 1;
        tail += ::wsprintf(tail, TEXT("Resume%d=%d"), i, (*it).resumePos) + 1;
    }
    tail[0] = 0;
    ::WritePrivateProfileSection(TEXT("FileInfo"), str, m_szIniFileName);
    delete [] str;
}


// vOCLɂꂽ̏
bool CTvtPlay::InitializePlugin()
{
    if (m_fInitialized) return true;

    // EBhENX̓o^
    WNDCLASS wc;
    wc.style            = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc      = FrameWindowProc;
    wc.cbClsExtra       = 0;
    wc.cbWndExtra       = 0;
    wc.hInstance        = g_hinstDLL;
    wc.hIcon            = NULL;
    wc.hCursor          = NULL;
    wc.hbrBackground    = (HBRUSH)GetStockObject(BLACK_BRUSH);
    wc.lpszMenuName     = NULL;
    wc.lpszClassName    = TVTPLAY_FRAME_WINDOW_CLASS;
    if (!::RegisterClass(&wc)) return false;

    LoadSettings();

    // ACR摜ǂݍ
    DrawUtil::CBitmap iconMap;
    if (m_szIconFileName[0])
        iconMap.Load(NULL, m_szIconFileName, LR_CREATEDIBSECTION | LR_LOADFROMFILE);
    if (!iconMap.IsCreated())
        if (!iconMap.Load(g_hinstDLL, IDB_BUTTONS)) return false;

    DrawUtil::CBitmap icon;
    if (!icon.Create(ICON_SIZE * 2, ICON_SIZE, 1)) return false;

    HDC hdcMem = ::CreateCompatibleDC(NULL);
    if (!hdcMem) return false;
    HGDIOBJ hgdiOld = ::SelectObject(hdcMem, icon.GetHandle());

    RGBQUAD rgbq[2] = {0};
    rgbq[1].rgbBlue = rgbq[1].rgbGreen = rgbq[1].rgbRed = 255;
    ::SetDIBColorTable(hdcMem, 0, 2, rgbq);

    // ͂ă{^ACe𐶐
    m_buttonNum = 0;
    for (int i = 0; i < BUTTON_MAX; i++) {
        if (m_buttonList[i][0] == TEXT(';')) continue;

        int commandID = -1;
        LPCTSTR cmd = ::StrRChr(m_buttonList[i], NULL, TEXT(','));
        for (int j = 0; cmd && j < ARRAY_SIZE(COMMAND_LIST); j++) {
            if (!::lstrcmpi(&cmd[1], COMMAND_LIST[j].pszText)) {
                commandID = COMMAND_LIST[j].ID;
                break;
            }
        }
        if (commandID == -1) continue;

        ComposeMonoColorIcon(hdcMem, 0, 0, iconMap.GetHandle(), m_buttonList[i]);

        m_statusView.AddItem(new CButtonStatusItem(this, STATUS_ITEM_BUTTON + commandID, icon));
        m_buttonNum++;
    }
    ::SelectObject(hdcMem, hgdiOld);
    ::DeleteDC(hdcMem);

    m_statusView.AddItem(new CSeekStatusItem(this, m_fSeekDrawTot));
    m_statusView.AddItem(new CPositionStatusItem(this, m_fPosDrawTot, m_posItemWidth));

    // CTsSenderݒ
    m_tsSender.SetConvTo188(m_fConvTo188);

    m_fInitialized = true;
    return true;
}


// vOC̗LԂω
bool CTvtPlay::EnablePlugin(bool fEnable) {
    if (fEnable) {
        if (!InitializePlugin()) return false;

        if (!m_hwndFrame) {
            m_hwndFrame = ::CreateWindow(TVTPLAY_FRAME_WINDOW_CLASS, NULL, WS_POPUP, 
                                         CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
                                         m_pApp->GetAppWindow(), NULL, g_hinstDLL, this);
            if (!m_hwndFrame) return false;
        }

        if (!m_statusView.Create(m_hwndFrame, WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS)) {
            ::DestroyWindow(m_hwndFrame);
            m_hwndFrame = NULL;
            return false;
        }
        m_statusView.SetEventHandler(&m_eventHandler);

        m_fFullScreen = false;
        Resize();
        ::ShowWindow(m_hwndFrame, SW_SHOW);

        m_pApp->SetWindowMessageCallback(WindowMsgCallback, this);
        ::DragAcceptFiles(m_pApp->GetAppWindow(), TRUE);
    }
    else {
        ::DragAcceptFiles(m_pApp->GetAppWindow(), FALSE);
        m_pApp->SetWindowMessageCallback(NULL, NULL);
        Close();

        if (m_hwndFrame) {
            m_statusView.SetEventHandler(NULL);
            m_statusView.Destroy();
            ::DestroyWindow(m_hwndFrame);
            m_hwndFrame = NULL;
        }
    }
    return true;
}


// _CAOIŃt@CJ
bool CTvtPlay::Open(HWND hwndOwner)
{
    TCHAR fileName[MAX_PATH];
    fileName[0] = 0;

    OPENFILENAME ofn = {0};
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner   = hwndOwner;
    ofn.lpstrFilter = TEXT("MPEG-2 TS(*.ts;*.m2t;*.m2ts)\0*.ts;*.m2t;*.m2ts\0ׂẴt@C\0*.*\0");
    ofn.lpstrFile   = fileName;
    ofn.nMaxFile    = ARRAY_SIZE(fileName);
    ofn.lpstrTitle  = TEXT("TSt@CJ");
    // MSDNLqƈႢOFN_NOCHANGEDIRGetOpenFileName()ɂʂ͗l
    ofn.Flags       = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;

    if (!::GetOpenFileName(&ofn)) return false;
    return Open(fileName);
}


// Rg[̃|bvAbvj[IŃt@CJ
bool CTvtPlay::Open(const POINT &pt, UINT flags)
{
    if (m_popupMax <= 0 || m_fPopuping) return false;

    // wqTVTest̕ۑtH_ɒu(蔲)
    TCHAR pattern[MAX_PATH];
    if (!::StrCmpNI(m_szPopupPattern, TEXT("%RecordFolder%"), 14)) {
        if (m_pApp->GetSetting(L"RecordFolder", pattern, ARRAY_SIZE(pattern)) <= 0) pattern[0] = 0;
        ::PathAppend(pattern, m_szPopupPattern + 14);
    }
    else {
        ::lstrcpy(pattern, m_szPopupPattern);
    }

    // t@CXg擾
    WIN32_FIND_DATA *findList = new WIN32_FIND_DATA[POPUP_MAX_MAX];
    int count = 0;
    HANDLE hFind = ::FindFirstFile(pattern, &findList[count]);
    if (hFind != INVALID_HANDLE_VALUE) {
        for (count++; count < POPUP_MAX_MAX; count++) {
            if (!::FindNextFile(hFind, &findList[count])) break;
        }
        ::FindClose(hFind);
    }

    // t@Cor~\[g
    LPCTSTR nameList[POPUP_MAX_MAX];
    for (int i = 0; i < count; i++) nameList[i] = findList[i].cFileName;
    qsort(nameList, count, sizeof(nameList[0]), m_fPopupDesc ? CompareTStrIX : CompareTStrI);

    // j[
    int selID = 0;
    HMENU hmenu = ::CreatePopupMenu();
    if (hmenu) {
        if (count == 0) {
            ::AppendMenu(hmenu, MF_STRING | MF_GRAYED, 1, TEXT("(Ȃ)"));
        }
        else {
            for (int i = max(count - m_popupMax, 0); i < count; i++) {
                TCHAR str[64];
                ::lstrcpyn(str, nameList[i], 64);
                if (::lstrlen(str) == 63) ::lstrcpy(&str[60], TEXT("..."));
                // vtBNX΍
                for (LPTSTR p = str; *p; p++)
                    if (*p == TEXT('&')) *p = TEXT('_');
                ::AppendMenu(hmenu, MF_STRING, i + 1, str);
            }
        }

        m_fPopuping = true;
        // ܂Rg[\Ă
        if (m_pApp->GetFullscreen()) {
            ::SendMessage(m_hwndFrame, WM_TIMER, TIMER_ID_FULL_SCREEN, 0);
        }
        selID = (int)::TrackPopupMenu(hmenu, flags | TPM_NONOTIFY | TPM_RETURNCMD,
                                      pt.x, pt.y, 0, m_hwndFrame, NULL);
        ::DestroyMenu(hmenu);
        m_fPopuping = false;
    }

    TCHAR fileName[MAX_PATH];
    if (selID == 0 || selID - 1 >= count ||
        !::PathRemoveFileSpec(pattern) ||
        !::PathCombine(fileName, pattern, nameList[selID - 1]))
    {
        fileName[0] = 0;
    }

    delete [] findList;
    return fileName[0] ? Open(fileName) : false;
}


// JĂort@CJȂ
bool CTvtPlay::ReOpen()
{
    if (!m_szPrevFileName[0]) return false;
    return Open(m_szPrevFileName);
}


bool CTvtPlay::Open(LPCTSTR fileName)
{
    Close();

    if (!m_tsSender.Open(fileName, m_salt, m_fUseQpc)) return false;

    // W[񂪂΂̒n_܂ŃV[N
    LONGLONG hash = m_tsSender.GetFileHash();
    std::list<HASH_INFO>::const_iterator it = m_hashList.begin();
    for (; it != m_hashList.end(); it++) {
        if ((*it).hash == hash) {
            // 擪orI[5b͈̔͂̓W[Ȃ
            if (5000 < (*it).resumePos && (*it).resumePos < m_tsSender.GetDuration() - 5000) {
                m_tsSender.Seek((*it).resumePos - 3000);
            }
            break;
        }
    }

    if (m_pApp->GetVersion() < TVTest::MakeVersion(0,7,21))
        m_pApp->Reset(TVTest::RESET_VIEWER);

    m_hThreadEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL);
    if (!m_hThreadEvent) {
        m_tsSender.Close();
        return false;
    }

    m_hThread = ::CreateThread(NULL, 0, TsSenderThread, this, 0, &m_threadID);
    if (!m_hThread) {
        ::CloseHandle(m_hThreadEvent);
        m_hThreadEvent = NULL;
        m_tsSender.Close();
        return false;
    }

    if (m_threadPriority >= THREAD_PRIORITY_LOWEST &&
        m_threadPriority <= THREAD_PRIORITY_HIGHEST) {
        ::SetThreadPriority(m_hThread, m_threadPriority);
    }

    // Z[WL[ł܂ő҂
    ::WaitForSingleObject(m_hThreadEvent, INFINITE);

    // TSf[^̑ݒ
    SetUpDestination();

    ::lstrcpy(m_szPrevFileName, fileName);
    return true;
}


void CTvtPlay::Close()
{
    if (m_hThread) {
        ::PostThreadMessage(m_threadID, WM_QUIT, 0, 0);
        ::WaitForSingleObject(m_hThread, INFINITE);
        ::CloseHandle(m_hThread);
        m_hThread = NULL;
        ::CloseHandle(m_hThreadEvent);
        m_hThreadEvent = NULL;

        // ŗL񃊃Xg
        HASH_INFO hashInfo = {0};
        hashInfo.hash = m_tsSender.GetFileHash();
        std::list<HASH_INFO>::iterator it = m_hashList.begin();
        for (; it != m_hashList.end(); it++) {
            if ((*it).hash == hashInfo.hash) {
                hashInfo = *it;
                m_hashList.erase(it);
                break;
            }
        }
        hashInfo.resumePos = m_tsSender.GetPosition();

        // ŗL񃊃Xg̍łVʒuɒǉ
        if (!m_hashList.empty() && (int)m_hashList.size() >= m_hashListMax) {
            m_hashList.pop_back();
        }
        if (m_hashListMax > 0) {
            m_hashList.push_front(hashInfo);
            SaveSettings();
        }

        m_tsSender.Close();
    }
}


// hCȍԂɉTSf[^̓]ݒ肷
void CTvtPlay::SetUpDestination()
{
    TCHAR path[MAX_PATH];
    TVTest::ChannelInfo chInfo;

    m_pApp->GetDriverName(path, ARRAY_SIZE(path));
    LPCTSTR name = ::PathFindFileName(path);

    if (!::lstrcmpi(name, TEXT("BonDriver_UDP.dll"))) {
        if (m_pApp->GetCurrentChannelInfo(&chInfo) && m_hThread) {
            ::PostThreadMessage(m_threadID, WM_TS_SET_UDP, 0, 1234 + chInfo.Channel);
        }
    }
    else if (!::lstrcmpi(name, TEXT("BonDriver_Pipe.dll"))) {
        if (m_pApp->GetCurrentChannelInfo(&chInfo) && m_hThread) {
            ::PostThreadMessage(m_threadID, WM_TS_SET_PIPE, 0, chInfo.Channel);
        }
    }
    else {
        if (m_hThread) ::PostThreadMessage(m_threadID, WM_TS_SET_UDP, 0, -1);
    }
}

void CTvtPlay::ResetAndPostToSender(UINT Msg, WPARAM wParam, LPARAM lParam, bool fResetAll)
{
    if (m_hThread) {
        // ]~܂ő҂
        m_fHalt = true;
        ::ResetEvent(m_hThreadEvent);
        ::WaitForSingleObject(m_hThreadEvent, 1000);

        if (m_pApp->GetVersion() < TVTest::MakeVersion(0,7,21)) {
            // RESET_VIEWER̃fbhbN΍̂ߐɃZbg
            m_pApp->Reset(fResetAll ? TVTest::RESET_ALL : TVTest::RESET_VIEWER);
        }
        ::PostThreadMessage(m_threadID, Msg, wParam, lParam);
        m_fHalt = false;
    }
}

void CTvtPlay::Pause(bool fPause)
{
    ResetAndPostToSender(WM_TS_PAUSE, fPause, 0, false);
}

void CTvtPlay::SeekToBegin()
{
    ResetAndPostToSender(WM_TS_SEEK_BGN, 0, 0, m_fResetAllOnSeek);
}

void CTvtPlay::SeekToEnd()
{
    ResetAndPostToSender(WM_TS_SEEK_END, 0, 0, m_fResetAllOnSeek);
}

void CTvtPlay::Seek(int msec)
{
    ResetAndPostToSender(WM_TS_SEEK, 0, msec, m_fResetAllOnSeek);
}

void CTvtPlay::SetAutoLoop(bool fAutoLoop)
{
    m_fAutoLoop = fAutoLoop;
    m_statusView.UpdateItem(STATUS_ITEM_BUTTON + ID_COMMAND_LOOP);
    SaveSettings();
}

int CTvtPlay::GetStretchID() const
{
    for (int i = 0; i < COMMAND_STRETCH_MAX; i++) {
        if (m_stretchList[i] == m_speed) return i;
    }
    return -1;
}

void CTvtPlay::Stretch(int stretchID)
{
    int speed = 0 <= stretchID && stretchID < COMMAND_STRETCH_MAX ?
                m_stretchList[stretchID] : 100;

    // xݒlor̂Ƃ̓~[gtO
    bool fMute = speed < m_noMuteMin || m_noMuteMax < speed;
    if (m_hThread) ::PostThreadMessage(m_threadID, WM_TS_SET_SPEED, (fMute?4:0)|m_stretchMode, speed);
}

void CTvtPlay::Resize()
{
    if (m_pApp->GetFullscreen()) {
        // ؂ւɃo[ʊOɂ邱Ƃ
        HMONITOR hMon = ::MonitorFromWindow(m_hwndFrame, MONITOR_DEFAULTTONEAREST);
        MONITORINFO mi;
        mi.cbSize = sizeof(MONITORINFO);

        if (::GetMonitorInfo(hMon, &mi)) {
            ::SetWindowPos(m_hwndFrame, NULL,
                           mi.rcMonitor.left, mi.rcMonitor.bottom - (m_fToBottom ? STATUS_HEIGHT : STATUS_HEIGHT*2),
                           mi.rcMonitor.right - mi.rcMonitor.left, STATUS_HEIGHT, SWP_NOZORDER | SWP_NOACTIVATE);
        }
        if (!m_fFullScreen) {
            // tXN[\ւ̑J
            m_fHide = false;
            m_dispCount = 0;
            ::GetCursorPos(&m_lastCurPos);
            ::SetTimer(m_hwndFrame, TIMER_ID_FULL_SCREEN, TIMER_FULL_SCREEN_INTERVAL, NULL);
            m_fFullScreen = true;
        }
    }
    else {
        RECT rect;
        if (::GetWindowRect(m_pApp->GetAppWindow(), &rect)) {
            bool fMaximize = (::GetWindowLong(m_pApp->GetAppWindow(), GWL_STYLE) & WS_MAXIMIZE) != 0;
            ::SetWindowPos(m_hwndFrame, NULL, rect.left,
                           fMaximize ? rect.bottom - (STATUS_HEIGHT + m_statusMargin) : rect.bottom,
                           rect.right - rect.left, STATUS_HEIGHT + m_statusMargin, SWP_NOZORDER | SWP_NOACTIVATE);
        }
        if (m_fFullScreen) {
            // ʏ\ւ̑J
            ::KillTimer(m_hwndFrame, TIMER_ID_FULL_SCREEN);
            ::SetWindowPos(m_hwndFrame, m_pApp->GetAlwaysOnTop() ? HWND_TOPMOST : HWND_NOTOPMOST,
                           0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW | SWP_NOACTIVATE);
            m_fFullScreen = false;
        }
    }
}


void CTvtPlay::EnablePluginByDriverName()
{
    if (m_fAutoEnUdp || m_fAutoEnPipe) {
        TCHAR path[MAX_PATH];
        m_pApp->GetDriverName(path, ARRAY_SIZE(path));
        LPCTSTR name = ::PathFindFileName(path);

        // hCoɉėL؂ւ
        bool fEnable = false;
        if (m_fAutoEnUdp && !::lstrcmpi(name, TEXT("BonDriver_UDP.dll"))) fEnable = true;
        if (m_fAutoEnPipe && !::lstrcmpi(name, TEXT("BonDriver_Pipe.dll"))) fEnable = true;

        if (m_pApp->IsPluginEnabled() != fEnable) m_pApp->EnablePlugin(fEnable);
    }
}


void CTvtPlay::OnCommand(int id)
{
    switch (id) {
    case ID_COMMAND_OPEN:
        Open(m_hwndFrame);
        break;
    case ID_COMMAND_OPEN_POPUP:
        if (m_fPopuping) {
            ::PostMessage(m_hwndFrame, WM_KEYDOWN, VK_ESCAPE, 0);
            ::PostMessage(m_hwndFrame, WM_KEYUP, VK_ESCAPE, 0);
        }
        else {
            CStatusItem *pItem = m_statusView.GetItemByID(STATUS_ITEM_BUTTON + ID_COMMAND_OPEN);
            if (pItem) pItem->OnRButtonDown(0, 0);
        }
        break;
    case ID_COMMAND_CLOSE:
        Close();
        break;
    case ID_COMMAND_SEEK_BGN:
        SeekToBegin();
        break;
    case ID_COMMAND_SEEK_END:
        SeekToEnd();
        break;
    case ID_COMMAND_LOOP:
        SetAutoLoop(!IsAutoLoop());
        break;
    case ID_COMMAND_PAUSE:
        if (!IsOpen()) ReOpen();
        else Pause(!IsPaused());
        break;
    case ID_COMMAND_NOP:
        break;
    case ID_COMMAND_SEEK_A:
    case ID_COMMAND_SEEK_B:
    case ID_COMMAND_SEEK_C:
    case ID_COMMAND_SEEK_D:
    case ID_COMMAND_SEEK_E:
    case ID_COMMAND_SEEK_F:
    case ID_COMMAND_SEEK_G:
    case ID_COMMAND_SEEK_H:
        Seek(m_seekList[id - ID_COMMAND_SEEK_A]);
        break;
    case ID_COMMAND_STRETCH_A:
    case ID_COMMAND_STRETCH_B:
    case ID_COMMAND_STRETCH_C:
    case ID_COMMAND_STRETCH_D:
        Stretch(GetStretchID() == id - ID_COMMAND_STRETCH_A ?
                -1 : id - ID_COMMAND_STRETCH_A);
        break;
    }
    m_dispCount = m_timeoutOnCmd / TIMER_FULL_SCREEN_INTERVAL;
}


// CxgR[obN֐
// CxgNƌĂ΂
LRESULT CALLBACK CTvtPlay::EventCallback(UINT Event, LPARAM lParam1, LPARAM lParam2, void *pClientData)
{
    CTvtPlay *pThis = reinterpret_cast<CTvtPlay*>(pClientData);

    switch (Event) {
    case TVTest::EVENT_PLUGINENABLE:
        // vOC̗LԂω
        return pThis->EnablePlugin(lParam1 != 0);
    case TVTest::EVENT_FULLSCREENCHANGE:
        // Sʕ\Ԃω
        if (pThis->m_pApp->IsPluginEnabled())
            pThis->Resize();
        break;
    case TVTest::EVENT_DRIVERCHANGE:
        // hCoύXꂽ
        pThis->EnablePluginByDriverName();

        // ֎~NɃ`lݒ肳Ȃꍇ̑΍(ver.0.7.22)
        if (pThis->m_fEventExecute &&
            pThis->m_pApp->GetVersion() < TVTest::MakeVersion(0,7,22))
        {
            TCHAR path[MAX_PATH];
            pThis->m_pApp->GetDriverName(path, ARRAY_SIZE(path));
            LPCTSTR name = ::PathFindFileName(path);

            if (pThis->m_pApp->IsPluginEnabled() &&
                (!::lstrcmpi(name, TEXT("BonDriver_UDP.dll")) ||
                !::lstrcmpi(name, TEXT("BonDriver_Pipe.dll"))))
            {
                TVTest::ChannelInfo chInfo;
                if (!pThis->m_pApp->GetCurrentChannelInfo(&chInfo)) {
                    pThis->m_pApp->AddLog(L"SetChannel");
                    for (int ch=0; ch < 10; ch++) {
                        if (pThis->m_pApp->SetChannel(0, ch)) break;
                    }
                }
            }
        }
        pThis->m_fEventExecute = false;

        // R}hCɃpXw肳ĂΊJ
        if (pThis->m_pApp->IsPluginEnabled() && pThis->m_szSpecFileName[0]) {
            pThis->Open(pThis->m_szSpecFileName);
            pThis->m_szSpecFileName[0] = 0;
        }
        break;
    case TVTest::EVENT_CHANNELCHANGE:
        // `lύXꂽ
        if (pThis->m_pApp->IsPluginEnabled())
            pThis->SetUpDestination();
        break;
    case TVTest::EVENT_COMMAND:
        // R}hIꂽ
        if (pThis->m_pApp->IsPluginEnabled())
            pThis->OnCommand(static_cast<int>(lParam1));
        return TRUE;
    case TVTest::EVENT_EXECUTE:
        // N֎~ɕNꂽ
        // hCoύXOɌĂ΂̂ŁÂEVENT_DRIVERCHANGEĂ΂邩Ȃ
        pThis->AnalyzeCommandLine(reinterpret_cast<LPCWSTR>(lParam1), false);
        pThis->m_fEventExecute = true;
        // FALL THROUGH!
    case TVTest::EVENT_STARTUPDONE:
        // N̏I
        pThis->EnablePluginByDriverName();
        if (pThis->m_pApp->IsPluginEnabled()) {
            // R}hCɃpXw肳ĂΊJ
            if (pThis->m_szSpecFileName[0]) {
                pThis->Open(pThis->m_szSpecFileName);
                pThis->m_szSpecFileName[0] = 0;
            }
            // Nt[Y΍()
            if (pThis->m_fRaisePriority) {
                ::SetThreadPriority(::GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL);
            }
        }
        break;
    }
    return 0;
}


// EBhEbZ[WR[obN֐
// TRUEԂTVTestŃbZ[WȂȂ
// WM_CREATE͌Ă΂Ȃ
BOOL CALLBACK CTvtPlay::WindowMsgCallback(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT *pResult, void *pUserData)
{
    CTvtPlay *pThis = reinterpret_cast<CTvtPlay*>(pUserData);

    switch (uMsg) {
    case WM_SIZE:
        pThis->Resize();
        break;
    case WM_MOVE:
        if (!pThis->m_pApp->GetFullscreen()) {
            RECT rect;
            if (::GetWindowRect(hwnd, &rect)) {
                ::SetWindowPos(pThis->m_hwndFrame, NULL, rect.left, rect.bottom, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
            }
        }
        break;
    case WM_DROPFILES:
        {
            TCHAR fileName[MAX_PATH];
            if (::DragQueryFile((HDROP)wParam, 0, fileName, ARRAY_SIZE(fileName)) != 0) {
                pThis->Open(fileName);
            }
            ::DragFinish((HDROP)wParam);
        }
        return TRUE;
    }
    return FALSE;
}


// CStatusVieẘOgEChEvV[W
LRESULT CALLBACK CTvtPlay::FrameWindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    // WM_CREATÊƂs
    CTvtPlay *pThis = reinterpret_cast<CTvtPlay*>(::GetWindowLongPtr(hwnd, GWLP_USERDATA));

    switch (uMsg) {
    case WM_CREATE:
        {
            LPCREATESTRUCT pcs = reinterpret_cast<LPCREATESTRUCT>(lParam);
            pThis = reinterpret_cast<CTvtPlay*>(pcs->lpCreateParams);
            ::SetWindowLongPtr(hwnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(pThis));
        }
        break;
    case WM_TIMER:
        if (wParam == TIMER_ID_FULL_SCREEN) {
            HMONITOR hMonApp = ::MonitorFromWindow(hwnd, MONITOR_DEFAULTTONEAREST);
            POINT curPos;
            MONITORINFO mi;
            mi.cbSize = sizeof(MONITORINFO);

            if (::GetCursorPos(&curPos) && ::GetMonitorInfo(hMonApp, &mi)) {
                HMONITOR hMonCur = ::MonitorFromPoint(curPos, MONITOR_DEFAULTTONULL);
                // mi.rcMonitorcurPos͂ƂɉzXN[Wn
                bool isHoverd = hMonApp == hMonCur && mi.rcMonitor.bottom -
                                (pThis->m_fToBottom ? STATUS_HEIGHT : STATUS_HEIGHT*2) < curPos.y;

                // J[\ړƂɕ\
                POINT lastPos = pThis->m_lastCurPos;
                if (pThis->m_timeoutOnMove > 0 && hMonApp == hMonCur &&
                    (curPos.x < lastPos.x-2 || lastPos.x+2 < curPos.x ||
                     curPos.y < lastPos.y-2 || lastPos.y+2 < curPos.y))
                {
                    pThis->m_dispCount = pThis->m_timeoutOnMove / TIMER_FULL_SCREEN_INTERVAL;
                    pThis->m_lastCurPos = curPos;
                }

                if (pThis->m_dispCount > 0 || isHoverd || pThis->m_fPopuping) {
                    if (pThis->m_fHide) {
                        ::SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
                        pThis->m_fHide = false;
                    }
                    if (isHoverd) pThis->m_dispCount = 0;
                    else pThis->m_dispCount--;
                }
                else {
                    if (!pThis->m_fHide) {
                        ::ShowWindow(hwnd, SW_HIDE);
                        pThis->m_fHide = true;
                    }
                }
            }
        }
        else if (wParam == TIMER_ID_RESET_DROP) {
            TVTest::StatusInfo si;
            // hbvJEg肷RESETSTATUS
            if (!pThis->m_pApp->GetStatus(&si) || si.DropPacketCount == pThis->m_lastDropCount) {
                pThis->m_pApp->ResetStatus();
                ::KillTimer(hwnd, TIMER_ID_RESET_DROP);
            }
            pThis->m_lastDropCount = si.DropPacketCount;
        }
        break;
    case WM_SIZE:
        {
            bool fFull = pThis->m_pApp->GetFullscreen();
            int margin = fFull ? 0 : pThis->m_statusMargin;

            // V[No[TCY
            CStatusItem *pItemSeek = pThis->m_statusView.GetItemByID(STATUS_ITEM_SEEK);
            if (pItemSeek) {
                // V[No[ACeȊO̕Zo
                int cmpl = 0;
                int num = pThis->m_statusView.NumItems();
                int idSeek = pItemSeek->GetIndex();
                RECT rcMgn;
                pThis->m_statusView.GetItemMargin(&rcMgn);
                for (int i = 0; i < num; ++i) {
                    if (i != idSeek) {
                        cmpl += pThis->m_statusView.GetItem(i)->GetWidth() + rcMgn.left + rcMgn.right;
                    }
                }
                pItemSeek->SetWidth(LOWORD(lParam) - rcMgn.left - rcMgn.right - 2 - margin*2 - cmpl);
            }
            pThis->m_statusView.SetPosition(margin, 0, LOWORD(lParam) - margin*2,
                                            HIWORD(lParam) - margin + (fFull && pThis->m_fToBottom ? 1 : 0));
        }
        break;
    case WM_UPDATE_POSITION:
        {
            DWORD pos = static_cast<DWORD>(wParam);
            DWORD dur = static_cast<DWORD>(lParam);
            pThis->m_position = pos & 0x7fffffff;
            pThis->m_duration = dur & 0x7fffffff;
            pThis->m_fSpecialExt = (pos&0x80000000) != 0;
            pThis->m_fFixed = (dur&0x80000000) != 0;
            pThis->m_statusView.UpdateItem(STATUS_ITEM_SEEK);
            pThis->m_statusView.UpdateItem(STATUS_ITEM_POSITION);
        }
        break;
    case WM_UPDATE_TOT_TIME:
        pThis->m_totTime = static_cast<int>(lParam);
        pThis->m_statusView.UpdateItem(STATUS_ITEM_SEEK);
        break;
    case WM_UPDATE_F_PAUSED:
        pThis->m_fPaused = wParam != 0;
        pThis->m_statusView.UpdateItem(STATUS_ITEM_SEEK);
        pThis->m_statusView.UpdateItem(STATUS_ITEM_BUTTON + ID_COMMAND_PAUSE);
        break;
    case WM_UPDATE_SPEED:
        pThis->m_speed = static_cast<int>(lParam);
        for (int i = 0; i < COMMAND_STRETCH_MAX; i++) 
            pThis->m_statusView.UpdateItem(STATUS_ITEM_BUTTON + ID_COMMAND_STRETCH_A + i);
        break;
    case WM_QUERY_CLOSE:
        pThis->Close();
        break;
    case WM_QUERY_SEEK_BGN:
        pThis->SeekToBegin();
        break;
    case WM_QUERY_RESET:
        if (pThis->m_pApp->GetVersion() >= TVTest::MakeVersion(0,7,21)) {
            pThis->m_pApp->Reset((wParam && pThis->m_fResetAllOnSeek) ? TVTest::RESET_ALL : TVTest::RESET_VIEWER);
        }
        if (wParam && pThis->m_resetDropInterval > 0) {
            pThis->m_lastDropCount = 0;
            ::SetTimer(hwnd, TIMER_ID_RESET_DROP, pThis->m_resetDropInterval, NULL);
        }
        break;
    case WM_APPCOMMAND:
        // fBAL[΍(I[i[EBhEɂ͎őKv)
        ::SendMessage(::GetParent(hwnd), uMsg, wParam, lParam);
        return 0;
    }
    return ::DefWindowProc(hwnd, uMsg, wParam, lParam);
}


// TSf[^̑MXbh
DWORD WINAPI CTvtPlay::TsSenderThread(LPVOID pParam)
{
    MSG msg;
    CTvtPlay *pThis = static_cast<CTvtPlay*>(pParam);
    int posSec = -1, durSec = -1, totSec = -1;
    bool fPrevFixed = false;
    int resetCount = 5;

    pThis->m_tsSender.SetupQpc();

    // Rg[̕\Zbg
    pThis->m_tsSender.Pause(false);
    ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_F_PAUSED, 0, 0);

    for (;;) {
        BOOL rv = ::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
        ::SetEvent(pThis->m_hThreadEvent);
        if (rv) {
            if (msg.message == WM_QUIT) break;
            switch (msg.message) {
            case WM_TS_SET_UDP:
                if (1234 <= msg.lParam && msg.lParam <= 1243)
                    pThis->m_tsSender.SetUdpAddress(UDP_ADDR, static_cast<unsigned short>(msg.lParam));
                else
                    pThis->m_tsSender.SetUdpAddress("", 0);
                break;
            case WM_TS_SET_PIPE:
                if (0 <= msg.lParam && msg.lParam <= 9) {
                    TCHAR name[MAX_PATH];
                    ::wsprintf(name, PIPE_NAME, static_cast<int>(msg.lParam));
                    pThis->m_tsSender.SetPipeName(name);
                }
                else {
                    pThis->m_tsSender.SetPipeName(TEXT(""));
                }
                break;
            case WM_TS_PAUSE:
                pThis->m_tsSender.Pause(msg.wParam != 0);
                ::PostMessage(pThis->m_hwndFrame, WM_QUERY_RESET, 0, 0);
                ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_F_PAUSED, msg.wParam, 0);
                break;
            case WM_TS_SEEK_BGN:
                if (pThis->m_tsSender.SeekToBegin())
                    resetCount = 5;
                break;
            case WM_TS_SEEK_END:
                if (pThis->m_tsSender.SeekToEnd())
                    resetCount = 5;
                break;
            case WM_TS_SEEK:
                if (pThis->m_tsSender.Seek(static_cast<int>(msg.lParam)))
                    resetCount = 5;
                break;
            case WM_TS_SET_SPEED:
                {
                    int speed = static_cast<int>(msg.lParam);
                    if (!ASFilterSendMessage(WM_ASFLT_STRETCH, msg.wParam, MAKELPARAM(speed, 100))) {
                        // R}hs̏ꍇ͓ɂ
                        pThis->m_tsSender.SetSpeed(100, 100);
                        ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_SPEED, 0, 100);
                    }
                    else {
                        // e|ωꍇ͓]xύX
                        if (msg.wParam&1) pThis->m_tsSender.SetSpeed(speed, 100);
                        ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_SPEED, 0, speed);
                    }
                }
                break;
            }
            ::TranslateMessage(&msg);
            ::DispatchMessage(&msg);
        }
        else if (pThis->m_fHalt) {
            ::Sleep(10);
        }
        else {
            bool fRead = pThis->m_tsSender.Send();

            int num, den;
            pThis->m_tsSender.GetSpeed(&num, &den);
            if (num != 100) {
                bool fSpecialExt;
                // t@CɒBAeʊmۘ^̒ǂ(Đ-3)bȏ̈ʒuɒBꍇ
                if (!fRead || (!pThis->m_tsSender.IsFixed(&fSpecialExt) && fSpecialExt &&
                    pThis->m_tsSender.GetPosition() > pThis->m_tsSender.GetDuration() - 3000))
                {
                    // ɖ߂Ă
                    ASFilterPostMessage(WM_ASFLT_STRETCH, 0, MAKELPARAM(100, 100));
                    pThis->m_tsSender.SetSpeed(100, 100);
                    ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_SPEED, 0, 100);
                }
            }
            if (!fRead) {
                if (pThis->m_tsSender.IsFixed()) {
                    // [vĐɕĂ͂Ȃ
                    if (pThis->m_fAutoLoop) {
                        ::Sleep(800);
                        ::PostMessage(pThis->m_hwndFrame, WM_QUERY_SEEK_BGN, 0, 0);
                    }
                    else if (pThis->m_fAutoClose) ::PostMessage(pThis->m_hwndFrame, WM_QUERY_CLOSE, 0, 0);
                }
            }
            if (!fRead || pThis->m_tsSender.IsPaused()) {
                resetCount = 0;
                ::Sleep(100);
            }
            else if (resetCount > 0 && --resetCount == 0) {
                // V[ÑZbg͂x]Ăs
                ::PostMessage(pThis->m_hwndFrame, WM_QUERY_RESET, 1, 0);
            }
        }

        int pos = pThis->m_tsSender.GetPosition();
        int dur = pThis->m_tsSender.GetDuration();
        int tot = pThis->m_tsSender.GetBroadcastTime();
        bool fSpecialExt;
        bool fFixed = pThis->m_tsSender.IsFixed(&fSpecialExt);

        // Đʒu̍XV`
        if (posSec != pos / 1000 || durSec != dur / 1000 || fPrevFixed != fFixed) {
            ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_POSITION,
                          fSpecialExt ? 0x80000000|(DWORD)pos : pos,
                          fFixed ? 0x80000000|(DWORD)dur : dur);
            posSec = pos / 1000;
            durSec = dur / 1000;
            fPrevFixed = fFixed;
        }
        // ̍XV`
        if (totSec != tot / 1000) {
            ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_TOT_TIME, 0, tot);
            totSec = tot / 1000;
        }
    }

    // ɖ߂Ă(Xbh҂Ă̂SendMessageĂ͂Ȃ)
    ASFilterPostMessage(WM_ASFLT_STRETCH, 0, MAKELPARAM(100, 100));
    pThis->m_tsSender.SetSpeed(100, 100);
    ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_SPEED, 0, 100);

    // Rg[̕\Zbg
    pThis->m_tsSender.Pause(false);
    ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_F_PAUSED, 0, 0);
    ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_POSITION, 0, 0);
    ::PostMessage(pThis->m_hwndFrame, WM_UPDATE_TOT_TIME, 0, -1);
    return 0;
}


TVTest::CTVTestPlugin *CreatePluginClass()
{
    return new CTvtPlay;
}




void CStatusViewEventHandler::OnMouseLeave()
{
    CStatusItem *pItem = m_pStatusView->GetItemByID(STATUS_ITEM_SEEK);
    if (pItem) {
        // Ɖc
        CSeekStatusItem *pSeekItem = dynamic_cast<CSeekStatusItem*>(pItem);
        pSeekItem->SetDrawSeekPos(false, 0);
        pSeekItem->Update();
    }
}


CSeekStatusItem::CSeekStatusItem(CTvtPlay *pPlugin, bool fDrawTot)
    : CStatusItem(STATUS_ITEM_SEEK, 128)
    , m_pPlugin(pPlugin)
    , m_fDrawSeekPos(false)
{
    m_MinWidth = 128;
    m_fDrawTot = fDrawTot;
}

void CSeekStatusItem::Draw(HDC hdc, const RECT *pRect)
{
    int dur = m_pPlugin->GetDuration();
    int pos = m_pPlugin->GetPosition();
    COLORREF crText = ::GetTextColor(hdc);
    COLORREF crBar = m_pPlugin->IsPaused() ? MixColor(crText, ::GetBkColor(hdc), 128) : crText;
    HPEN hpen, hpenOld;
    HBRUSH hbr, hbrOld;
    RECT rcBar, rc;

    // o[̍ő`(Og܂܂Ȃ)
    rcBar.left   = pRect->left + 2;
    rcBar.top    = pRect->top + (pRect->bottom - pRect->top - 8) / 2 + 2;
    rcBar.right  = pRect->right - 2;
    rcBar.bottom = rcBar.top + 8 - 4;

    // ۂɕ`悷o[̉E[ʒu
    int barPos = min(rcBar.right, rcBar.left + (dur <= 0 ? 0 :
                 (int)((long long)(rcBar.right - rcBar.left) * pos / dur)));

    // V[Nʒu`悷邩ǂ
    bool fDrawPos = m_fDrawSeekPos && rcBar.left <= m_seekPos && m_seekPos < rcBar.right;

    // V[Nʒu`
    int drawPosWidth = 64;
    int drawPos = 0;
    if (fDrawPos) {
        TCHAR szText[128];
        TCHAR szTotText[128];
        int posSec = (int)((long long)(m_seekPos-rcBar.left) * dur / (rcBar.right-rcBar.left) / 1000);

        szTotText[0] = 0;
        if (m_fDrawTot) {
            int tot = m_pPlugin->GetTotTime();
            int totSec = tot / 1000 + posSec;
            if (tot < 0) ::lstrcpy(szTotText, TEXT(" (s)"));
            else ::wsprintf(szTotText, TEXT(" (%d:%02d:%02d)"), totSec/60/60%24, totSec/60%60, totSec%60);
        }

        if (dur < 3600000) ::wsprintf(szText, TEXT("%02d:%02d%s"), posSec/60%60, posSec%60, szTotText);
        else ::wsprintf(szText, TEXT("%d:%02d:%02d%s"), posSec/60/60, posSec/60%60, posSec%60, szTotText);

        // V[Nʒu̕`ɕKvȕ擾
        rc.left = rc.top = rc.right = rc.bottom = 0;
        if (::DrawText(hdc, szText, -1, &rc,
                       DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX | DT_CALCRECT))
            drawPosWidth = rc.right - rc.left + 10;

        m_fDrawLeft = m_seekPos >= rcBar.left + drawPosWidth + 4 &&
                      (m_seekPos >= rcBar.right - drawPosWidth - 4 ||
                      m_seekPos < barPos - 3 || m_seekPos < barPos + 3 && m_fDrawLeft);
        drawPos = m_fDrawLeft ? m_seekPos - drawPosWidth - 4 : m_seekPos + 5;

        // V[Nʒu`
        rc.left = drawPos + 5;
        rc.top = pRect->top;
        rc.right = drawPos + drawPosWidth;
        rc.bottom = pRect->bottom;
        ::DrawText(hdc, szText, -1, &rc,
                   DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
    }

    // o[̊Og`
    hpen = ::CreatePen(PS_SOLID, 1, crText);
    hpenOld = SelectPen(hdc, hpen);
    hbrOld = SelectBrush(hdc, ::GetStockObject(NULL_BRUSH));
    rc.left   = rcBar.left - 2;
    rc.top    = rcBar.top - 2;
    rc.right  = rcBar.right + 2;
    rc.bottom = rcBar.bottom + 2;
    if (fDrawPos) {
        ::Rectangle(hdc, rc.left, rc.top, drawPos, rc.bottom);
        ::Rectangle(hdc, drawPos + drawPosWidth, rc.top, rc.right, rc.bottom);
    }
    else {
        ::Rectangle(hdc, rc.left, rc.top, rc.right, rc.bottom);
    }
    ::SelectObject(hdc, hbrOld);
    ::SelectObject(hdc, hpenOld);
    ::DeleteObject(hpen);

    // o[`
    hbr = ::CreateSolidBrush(crBar);
    rc = rcBar;
    rc.right = barPos;
    if (fDrawPos) {
        int right = rc.right;
        if (rc.right > drawPos - 2) rc.right = drawPos - 2;
        ::FillRect(hdc, &rc, hbr);
        rc.right = right;

        if (rc.right >= drawPos + drawPosWidth + 2) {
            rc.left = drawPos + drawPosWidth + 2;
            ::FillRect(hdc, &rc, hbr);
        }
    }
    else {
        ::FillRect(hdc, &rc, hbr);
    }
    ::DeleteObject(hbr);
}

void CSeekStatusItem::OnLButtonDown(int x, int y)
{
    RECT rc;
    GetClientRect(&rc);

    if (x <= 6) {
        m_pPlugin->SeekToBegin();
    }
    else if (x >= rc.right-rc.left+8-6) {
        m_pPlugin->SeekToEnd();
    }
    else {
        int pos = m_pPlugin->GetPosition();
        int dur = m_pPlugin->GetDuration();
        int targetPos = (int)((long long)(x-4-2) * dur / ((rc.right-2) - (rc.left+2)));
        // ƎOɃV[Nꂽg₷1000~b
        m_pPlugin->Seek(targetPos - pos - 1000);
    }
}

void CSeekStatusItem::OnRButtonDown(int x, int y)
{
    m_pPlugin->Pause(!m_pPlugin->IsPaused());
}

void CSeekStatusItem::OnMouseMove(int x, int y)
{
    SetDrawSeekPos(true, x);
    Update();
}

void CSeekStatusItem::SetDrawSeekPos(bool fDraw, int pos)
{
    if (fDraw && !m_fDrawSeekPos) m_fDrawLeft = false;
    m_fDrawSeekPos = fDraw;
    m_seekPos = pos;
}


CPositionStatusItem::CPositionStatusItem(CTvtPlay *pPlugin, bool fDrawTot, int width)
    : CStatusItem(STATUS_ITEM_POSITION, width < 0 ? 112 : width)
    , m_pPlugin(pPlugin)
{
    m_MinWidth = m_DefaultWidth;
    m_fDrawTot = fDrawTot;
}

void CPositionStatusItem::Draw(HDC hdc, const RECT *pRect)
{
    TCHAR szText[128];
    TCHAR szTotText[128];
    int posSec = m_pPlugin->GetPosition() / 1000;
    int durSec = m_pPlugin->GetDuration() / 1000;
    bool fSpecialExt;

    szTotText[0] = 0;
    if (m_fDrawTot) {
        int tot = m_pPlugin->GetTotTime();
        int totSec = tot / 1000 + posSec;
        if (tot < 0) ::lstrcpy(szTotText, TEXT(" (s)"));
        else ::wsprintf(szTotText, TEXT(" (%d:%02d:%02d)"), totSec/60/60%24, totSec/60%60, totSec%60);
    }

    if (durSec < 60 * 60 && posSec < 60 * 60) {
        ::wsprintf(szText, TEXT("%02d:%02d/%02d:%02d%s%s"),
                   posSec / 60 % 60, posSec % 60,
                   durSec / 60 % 60, durSec % 60,
                   m_pPlugin->IsFixed(&fSpecialExt) ? TEXT("") : fSpecialExt ? TEXT("*") : TEXT("+"),
                   szTotText);
    }
    else {
        ::wsprintf(szText, TEXT("%d:%02d:%02d/%d:%02d:%02d%s%s"),
                   posSec / 60 / 60, posSec / 60 % 60, posSec % 60,
                   durSec / 60 / 60, durSec / 60 % 60, durSec % 60,
                   m_pPlugin->IsFixed(&fSpecialExt) ? TEXT("") : fSpecialExt ? TEXT("*") : TEXT("+"),
                   szTotText);
    }
    DrawText(hdc, pRect, szText);
}


CButtonStatusItem::CButtonStatusItem(CTvtPlay *pPlugin, int id, const DrawUtil::CBitmap &icon)
    : CStatusItem(id, 16)
    , m_pPlugin(pPlugin)
    , m_icon(icon)
{
    m_MinWidth = 16;
}

void CButtonStatusItem::Draw(HDC hdc, const RECT *pRect)
{
    // PauseLoopStretch͓ʈ
    int cmdID = m_ID - STATUS_ITEM_BUTTON;
    if ((cmdID == ID_COMMAND_PAUSE && (!m_pPlugin->IsOpen() || m_pPlugin->IsPaused())) ||
        (cmdID == ID_COMMAND_LOOP && m_pPlugin->IsAutoLoop()) ||
        (ID_COMMAND_STRETCH_A <= cmdID && cmdID <= ID_COMMAND_STRETCH_D &&
         m_pPlugin->GetStretchID() == cmdID - ID_COMMAND_STRETCH_A))
    {
        DrawIcon(hdc, pRect, m_icon.GetHandle(), ICON_SIZE);
    }
    else {
        DrawIcon(hdc, pRect, m_icon.GetHandle(), 0);
    }
}

void CButtonStatusItem::OnLButtonDown(int x, int y)
{
    m_pPlugin->OnCommand(m_ID - STATUS_ITEM_BUTTON);
}

void CButtonStatusItem::OnRButtonDown(int x, int y)
{
    // Open͓ʈ
    if (m_ID-STATUS_ITEM_BUTTON == ID_COMMAND_OPEN) {
        POINT pt;
        UINT flags;
        if (GetMenuPos(&pt, &flags)) {
            m_pPlugin->Open(pt, flags);
        }
    }
}
